Package: ADImpute
Type: Package
Title: Adaptive Dropout Imputer (ADImpute)
Version: 1.20.0
Description: Single-cell RNA sequencing (scRNA-seq) methods are typically unable
    to quantify the expression levels of all genes in a cell, creating a need
    for the computational prediction of missing values (‘dropout imputation’).
    Most existing dropout imputation methods are limited in the sense that they
    exclusively use the scRNA-seq dataset at hand and do not exploit external
    gene-gene relationship information. Here we propose two novel methods: a
    gene regulatory network-based approach using gene-gene relationships learnt
    from external data and a baseline approach corresponding to a sample-wide
    average. ADImpute can implement these novel methods and also combine them
    with existing imputation methods (currently supported: DrImpute, SAVER).
    ADImpute can learn the best performing method per gene and combine the
    results from different methods into an ensemble.
Authors@R: person("Ana Carolina", "Leote", email = "anacarolinaleote@gmail.com",
           role = c("cre","aut"), comment = c(ORCID = "0000-0003-0879-328X"))
License: GPL-3 + file LICENSE
Encoding: UTF-8
LazyData: true
Depends: R (>= 4.0)
Imports: checkmate, BiocParallel, data.table, DrImpute, kernlab, MASS,
        Matrix, methods, rsvd, S4Vectors, SAVER, SingleCellExperiment,
        stats, SummarizedExperiment, utils
Suggests: BiocStyle, knitr, rmarkdown, testthat
biocViews: GeneExpression, Network, Preprocessing, Sequencing,
        SingleCell, Transcriptomics
RoxygenNote: 7.1.1
VignetteBuilder: knitr
BugReports: https://github.com/anacarolinaleote/ADImpute/issues
git_url: https://git.bioconductor.org/packages/ADImpute
git_branch: RELEASE_3_22
git_last_commit: 4634280
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 02:26:33 UTC; biocbuild
Author: Ana Carolina Leote [cre, aut] (ORCID:
    <https://orcid.org/0000-0003-0879-328X>)
Maintainer: Ana Carolina Leote <anacarolinaleote@gmail.com>

# ADImpute predicts unmeasured gene expression values from single cell
# RNA-sequencing data (dropout imputation). This R-package combines multiple
# dropout imputation methods, including a novel gene regulatory
# network-based method.  Copyright (C) 2020 Ana Carolina Leote This program
# is free software: you can redistribute it and/or modify it under the terms
# of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.  You should have received a copy of the
# GNU General Public License along with this program.  If not, see
# <https://www.gnu.org/licenses/>.


#' @title Method choice per gene
#'
#' @usage ChooseMethod(real, masked, imputed, write.to.file = TRUE)
#'
#' @description \code{ChooseMethod} determines the method for dropout
#' imputation based on performance on each gene in training data
#'
#' @param real matrix; original gene expression data, i.e. before masking
#' (genes as rows and samples as columns)
#' @param masked matrix, logical indicating which entries were masked
#' (genes as rows and samples as columns)
#' @param imputed list; list of matrices with imputation results for all
#' considered methods
#' @param write.to.file logical; should the output be written to a file?
#'
#' @details The imputed values are compared to the real ones for every masked
#' entry in \code{real}. The Mean Squared Error
#' is computed for all masked entries per gene and the method with the best
#' performance is chosen for each gene.
#'
#' @return character; best performing method in the training set for each gene
#'
#' @seealso \code{\link{ComputeMSEGenewise}}
#'
ChooseMethod <- function(real, masked, imputed, write.to.file = TRUE) {

    if (!all(colnames(real) == colnames(masked)) &&
        all(rownames(real) == rownames(masked)))
        stop("Error! Dimnames before and after masking don't match.\n")

    which_masked <- (real != 0) & (masked == 0)  # distinguishes masked values
    # from dropouts in the original data

    MSE <- lapply(imputed, function(x) vapply(rownames(real), function(g) {
        if (g %in% rownames(x)) {
            ComputeMSEGenewise(real = real[g, ], masked = which_masked[g, ],
                imputed = x[g, ], baseline = identical(x, imputed$Baseline))
        } else {
            NA
        }
    }, FUN.VALUE = 1))
    MSE <- do.call(cbind, MSE)

    # keep cases where at least 2 methods are available for comparison
    MSE <- MSE[which(rowSums(!is.na(MSE)) >= 2), ]

    message(paste("Imputation errors computed for", nrow(MSE), "genes\n"))

    best_method <- vapply(apply(MSE, 1, which.min),
        function(x) colnames(MSE)[x], FUN.VALUE = "Method_name")

    if (write.to.file)
        WriteTXT(cbind(MSE, best_method), "method_choices.txt")

    return(best_method)
}


#' @title Computation of MSE per gene
#'
#' @usage ComputeMSEGenewise(real, masked, imputed, baseline)
#'
#' @description \code{ComputeMSEGenewise} computes the MSE of dropout
#' imputation for a given gene.
#'
#' @param real numeric; vector of original expression of a given gene (before
#' masking)
#' @param masked logical; vector indicating which entries were masked for a
#' given gene
#' @param imputed matrix; imputation results for a given imputation method
#' @param baseline logical; is this baseline imputation?
#'
#' @return MSE of all imputations indicated by \code{masked}
#'
ComputeMSEGenewise <- function(real, masked, imputed, baseline) {
    if (baseline) {
        index <- masked  # Baseline always imputes
        if (sum(index) == 0) {
            mse <- NA
        } else {
            mse <- sum((imputed[index] - real[index])^2, na.rm = TRUE)/
                sum(index, na.rm = TRUE)
        }
    } else {
        index <- masked & (imputed != 0)  # not assess if value is not imputed
        if (sum(index) == 0) {
            mse <- NA
        } else {
            mse <- sum((imputed[index] - real[index])^2, na.rm = TRUE)/
                sum(index, na.rm = TRUE)
        }
    }

    return(mse)
}


#' @title Preparation of training data for method evaluation
#'
#' @usage CreateTrainData(data, train.ratio = .7, train.only = TRUE, mask = .1,
#' write = FALSE)
#'
#' @description \code{CreateTrainingData} selects a subset of cells to use as
#' training set and sets a portion (\code{mask}) of the non-zero entries in each
#' row of the subset to zero
#'
#' @param data matrix; raw counts (genes as rows and samples as columns)
#' @param train.ratio numeric; ratio of the samples to be used for training
#' @param train.only logical; if TRUE define only a training dataset, if
#' FALSE writes both training and validation sets (defaults to TRUE)
#' @param mask numeric; ratio of total non-zero samples to be masked per gene
#' (defaults to .1)
#' @param write logical; should the output be written to a file?
#'
#' @return list with resulting matrix after subsetting and after masking
#'
CreateTrainData <- function(data, train.ratio = 0.7, train.only = TRUE,
                            mask = 0.1, write = FALSE) {

    # Split data for training
    train_norm <- SplitData(data, ratio = train.ratio, write.to.file = write,
        train.only = train.only)

    # Mask selected training data
    masked_train_norm <- MaskData(train_norm, write.to.file = write,
        mask = mask)

    return(list(train = train_norm, mask = masked_train_norm))
}


#' @title Masking of entries for performance evaluation
#'
#' @usage MaskData(data, write.to.file = FALSE, mask = .1)
#'
#' @description \code{MaskData} sets a portion (\code{mask}) of the non-zero
#' entries of each row of \code{data} to zero
#'
#' @param data matrix; raw counts (genes as rows and samples as columns)
#' @param write.to.file logical; should the output be written to a file?
#' @param mask numeric; ratio of total non-zero samples to be masked per gene
#' (defaults to .1)
#'
#' @details Sets a portion (\code{mask}) of the non-zero entries of each row of
#' \code{data} to zero. Result is written to \code{filename}.
#'
#' @return matrix containing masked raw counts (genes as rows and samples as
#' columns)
#'
MaskData <- function(data, write.to.file = FALSE, mask = 0.1) {

    message("Masking training data\n")

    data <- DataCheck_Matrix(data)

    # Original matrix sparcity
    sparcity <- sprintf("%.2f", sum(data == 0)/length(data))
    message("original sparcity", sparcity, "\n")

    rowmask <- round(mask * ncol(data))  # samples to be masked per gene
    maskable <- data != 0  # maskable samples (originally not dropouts)

    maskidx <- t(vapply(seq_len(nrow(maskable)),
        function(x) MaskerPerGene(maskable[x, ], rowmask = rowmask),
        FUN.VALUE = rep(FALSE, ncol(data))))

    data[maskidx] <- 0
    sparcity <- sprintf("%.2f", sum(data == 0)/length(data))
    message("final sparcity", sparcity, "\n")

    # Write to file
    if (write.to.file)
        WriteTXT(data, "masked_data.txt")

    return(data)
}


#' @title Helper mask function
#'
#' @usage MaskerPerGene(x, rowmask)
#'
#' @description Helper mask function, per feature.
#'
#' @param x logical; data to mask
#' @param rowmask numeric; number of samples to be masked per gene
#'
#' @return logical containing positions to mask
#'
MaskerPerGene <- function(x, rowmask) {
    if (sum(x) > rowmask) {
        # Randomly pick samples to mask
        tomask <- sample(which(x), rowmask)
        out <- rep(FALSE, length(x))
        out[tomask] <- TRUE
        names(out) <- names(x)

        return(out)

    } else {
        # Not enough non-dropout samples to mask up to defined ratio, mask all
        return(x)
    }
}


#' @title Selection of samples for training
#'
#' @description \code{SplitData} selects a portion (\code{ratio}) of samples
#' (columns in \code{data}) to be used as training set
#'
#' @usage SplitData(data, ratio = .7, write.to.file = FALSE, train.only = TRUE)
#'
#' @param data matrix; raw counts (genes as rows and samples as columns)
#' @param ratio numeric; ratio of the samples to be used for training
#' @param write.to.file logical; should the output be written to a file?
#' @param train.only logical; if TRUE define only a training dataset, if
#' FALSE writes both training and validation sets (defaults to TRUE)
#'
#' @details Selects a portion (\code{ratio}) of samples (columns in \code{data})
#' to be used as training set and writes to file 'training_raw.txt'.
#'
#' @return matrix containing raw counts (genes as rows and samples as columns)
#'
SplitData <- function(data, ratio = 0.7, write.to.file = FALSE,
    train.only = TRUE) {

    message("Selecting training data\n")

    # Randomly select samples according to given ratio
    train_samples <- sample(colnames(data))[seq_len(round(ncol(data) * ratio))]
    train_data <- data[, train_samples]

    # Write to file
    if (write.to.file)
        WriteTXT(train_data, "training.txt")

    # Optionally create and write validation dataset
    if (!train.only) {
        validation_data <- data[, !(colnames(data) %in% train_samples)]
        if (write.to.file)
            WriteTXT(validation_data, "validation.txt")
    }

    return(train_data)
}

testdata <- matrix(data = seq_len(25), nrow = 5, ncol = 5, byrow = TRUE,
                 dimnames = list(paste("Gene", seq_len(5)),
                                 paste("Cell", seq_len(5))))
testdata2 <- testdata
testdata2[2,] <- 0
testdata3 <- testdata
testdata3[3,sample(seq_len(ncol(testdata3)),ncol(testdata3)-1)] <- 0


test_that("MaskData works", {

  # right number of entries per gene is masked
  expect_true(all(rowSums(MaskData(testdata, mask = 0.2) == 0) == 1))

  # handles well only 0 rows
  expect_equivalent(rowSums(MaskData(testdata2, mask = 0.2) == 0),
                    c(1,ncol(testdata2),rep(1,3)))

  # right number of entries per gene is masked with a lot of zeros
  expect_equivalent(rowSums(MaskData(testdata3, mask = 0.2) == 0),
                    c(1,1,ncol(testdata2),1,1))

})

## ----setup, include = FALSE---------------------------------------------------
is_check <- ("CheckExEnv" %in% search()) || any(c("_R_CHECK_TIMINGS_",
    "_R_CHECK_LICENSE_") %in% names(Sys.getenv()))
knitr::opts_chunk$set(eval = !is_check, collapse = TRUE, comment = "#>")
library(ADImpute)

## ----warning=FALSE, message=FALSE, eval=FALSE---------------------------------
# RPM <- NormalizeRPM(ADImpute::demo_data)
# imputed <- Impute(data = RPM, do = c("Network"), cores = 2,
#     net.coef = ADImpute::demo_net)

## ----warning=FALSE, message=FALSE, results=FALSE------------------------------
RPM <- NormalizeRPM(ADImpute::demo_data)
methods_pergene <- EvaluateMethods(data = RPM,
    do = c("Baseline", "DrImpute", "Network"),
    cores = 2, net.coef = ADImpute::demo_net)

## ----warning=FALSE------------------------------------------------------------
head(methods_pergene)

## ----warning=FALSE, message=FALSE, results=FALSE------------------------------
imputed <- Impute(do = "Ensemble", method.choice = methods_pergene,
    data = RPM, cores = 2, net.coef = ADImpute::demo_net)

## ----warning=FALSE------------------------------------------------------------
str(imputed)

## ----warning=FALSE, message=FALSE, results=FALSE------------------------------
imputed <- Impute(do = "Baseline",
    data = RPM,
    cores = 2,
    true.zero.thr = .3)

## ----warning=FALSE------------------------------------------------------------
str(imputed)

## ----warning=FALSE, message=FALSE, results=FALSE------------------------------
sce <- NormalizeRPM(sce = ADImpute::demo_sce)
sce <- EvaluateMethods(sce = sce)
sce <- Impute(sce = sce)

## ----warning=FALSE, eval=FALSE------------------------------------------------
# # # call to scImpute
# if('scimpute' %in% tolower(do)){
#     message('Make sure you have previously installed scImpute via GitHub.\n')
#     res <- tryCatch(ImputeScImpute(count_path, labeled = is.null(labels),
#             Kcluster = cell.clusters, labels = labels, drop_thre = drop_thre,
#             cores = cores, type = type, tr.length = tr.length),
#         error = function(e){ stop(paste('Error:', e$message,
#             '\nTry sourcing the Impute_extra.R file.'))})
#     imputed$scImpute <- log2( (res / scale) + pseudo.count)
# }
# 
# # call to SCRABBLE
# if('scrabble' %in% tolower(do)){
#     message('Make sure you have previously installed SCRABBLE via GitHub.\n')
#     res <- tryCatch(ImputeSCRABBLE(data, bulk),
#                     error = function(e) { stop(paste('Error:', e$message,
#                         '\nTry sourcing the Impute_extra.R file.'))})
#     imputed$SCRABBLE <- log2( (res / scale) + pseudo.count)
#     rm(res);gc()
# }

## -----------------------------------------------------------------------------
sessionInfo()

# ADImpute predicts unmeasured gene expression values from single cell
# RNA-sequencing data (dropout imputation). This R-package combines multiple
# dropout imputation methods, including a novel gene regulatory
# network-based method.  Copyright (C) 2020 Ana Carolina Leote This program
# is free software: you can redistribute it and/or modify it under the terms
# of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.  You should have received a copy of the
# GNU General Public License along with this program.  If not, see
# <https://www.gnu.org/licenses/>.


#' @title Imputation method evaluation on training set
#'
#' @usage EvaluateMethods(data, sce = NULL, do = c('Baseline', 'DrImpute',
#' 'Network'), write = FALSE, train.ratio = .7, train.only = TRUE,
#' mask.ratio = .1, outdir = getwd(), scale = 1, pseudo.count = 1,
#' labels = NULL, cell.clusters = 2, drop_thre = NULL, type = 'count',
#' cores = BiocParallel::bpworkers(BPPARAM),
#' BPPARAM = BiocParallel::SnowParam(type = "SOCK"),
#' net.coef = ADImpute::network.coefficients, net.implementation = 'iteration',
#' tr.length = ADImpute::transcript_length, bulk = NULL, ...)
#'
#' @description \code{EvaluateMethods} returns the best-performing imputation
#' method for each gene in the dataset
#'
#' @param data matrix; normalized counts, not logged (genes as rows and samples
#' as columns)
#' @param sce SingleCellExperiment; normalized counts and associated metadata.
#' @param do character; choice of methods to be used for imputation. Currently
#' supported methods are \code{'Baseline'}, \code{'DrImpute'} and
#' \code{'Network'}. Not case-sensitive. Can include one or more methods. Non-
#' supported methods will be ignored.
#' @param write logical; write intermediary and imputed objects to files?
#' @param train.ratio numeric; ratio of samples to be used for training
#' @param train.only logical; if TRUE define only a training dataset, if
#' FALSE writes and returns both training and validation sets (defaults to TRUE)
#' @param mask.ratio numeric; ratio of samples to be masked per gene
#' @param outdir character; path to directory where output files are written.
#' Defaults to working directory
#' @param scale integer; scaling factor to divide all expression levels by
#' (defaults to 1)
#' @param pseudo.count integer; pseudo-count to be added to expression levels
#' to avoid log(0) (defaults to 1)
#' @param labels character; vector specifying the cell type of each column of
#' \code{data}
#' @param cell.clusters integer; number of cell subpopulations
#' @param drop_thre numeric; between 0 and 1 specifying the threshold to
#' determine dropout values
#' @param type A character specifying the type of values in the expression
#' matrix. Can be 'count' or 'TPM'
#' @param cores integer; number of cores used for paralell computation
#' @param BPPARAM parallel back-end to be used during parallel computation.
#' See \code{\link[BiocParallel]{BiocParallelParam-class}}.
#' @param net.coef matrix; network coefficients. Please provide if you don't
#' want to use ADImpute's network model. Must contain one first column 'O'
#' acconting for the intercept of the model and otherwise be an adjacency matrix
#' with hgnc_symbols in rows and columns. Doesn't have to be squared. See
#' \code{ADImpute::demo_net} for a small example.
#' @param net.implementation character; either 'iteration', for an iterative
#' solution, or 'pseudoinv', to use Moore-Penrose pseudo-inversion as a
#' solution. 'pseudoinv' is not advised for big data.
#' @param tr.length matrix with at least 2 columns: 'hgnc_symbol' and
#' 'transcript_length'
#' @param bulk vector of reference bulk RNA-seq, if available (average across
#' samples)
#' @param ... additional parameters to pass to network-based imputation
#'
#' @details For each gene, a fraction (\code{mask.ratio}) of the quantified
#' expression values are set to zero and imputed according to 3 different
#' methods: scImpute, baseline (average gene expression across all cells) or a
#' network-based method. The imputation error is computed for each of the
#' values in the original dataset that was set to 0, for each method. The
#' method resulting in a lowest imputation error for each gene is chosen.
#'
#' @return
#'  \itemize{
#'     \item if \code{sce} is provided: returns a SingleCellExperiment with the
#'     best performing method per gene stored as row-features. Access via
#'     \code{SingleCellExperiment::int_elementMetadata(sce)$ADImpute$methods}.
#'     \item if \code{sce} is not provided: returns a character with the best
#'     performing method in the training set for each gene
#' }
#'
#' @examples
#' # Normalize demo data
#' norm_data <- NormalizeRPM(ADImpute::demo_data)
#' method_choice <- EvaluateMethods(norm_data, do = c('Baseline','DrImpute'),
#' cores = 2)
#'
#' @seealso \code{\link{ImputeBaseline}},
#' \code{\link{ImputeDrImpute}},
#' \code{\link{ImputeNetwork}}
#'
#' @export
#'
EvaluateMethods <- function(data, sce = NULL, do = c("Baseline", "DrImpute",
        "Network"), write = FALSE, train.ratio = 0.7, train.only = TRUE,
    mask.ratio = 0.1, outdir = getwd(), scale = 1, pseudo.count = 1,
    labels = NULL, cell.clusters = 2, drop_thre = NULL, type = "count",
    cores = BiocParallel::bpworkers(BPPARAM),
    BPPARAM = BiocParallel::SnowParam(type = "SOCK"),
    net.coef = ADImpute::network.coefficients, net.implementation = "iteration",
    tr.length = ADImpute::transcript_length, bulk = NULL, ...) {

    # Check arguments
    if(!is.null(sce)){
        DataCheck_SingleCellExperiment(sce)
        data <- SingleCellExperiment::normcounts(sce)
    }
    Check <- CreateArgCheck(missing = list(data = missing(data)),
        match = list(type = type), acceptable = list(type = c("TPM", "count")),
        null = list(net.coef = is.null(net.coef), data = is.null(data)))
    checkmate::reportAssertions(Check)
    data <- DataCheck_Matrix(data)
    tr.length <- DataCheck_TrLength(tr.length)

    if (sum(tolower(do) %in% c("baseline", "drimpute", "network")) < 2)
        warning(paste0("You are using less than 2 of the default supported ",
            "methods. Make sure you pass at least 2 viable methods ",
            "for performance comparison.\n"))

    if (write) {
        savedir <- getwd()
        dir.create(paste0(outdir, "/training"))
        setwd(paste0(outdir, "/training"))
        on.exit(setwd(savedir))
    }

    train_data <- CreateTrainData(data, train.ratio = train.ratio,
        train.only = train.only, mask = mask.ratio, write = write)

    train_imputed <- Impute(data = train_data$mask, do = do[do != "Ensemble"],
        write = write, outdir = getwd(), scale = scale,
        pseudo.count = pseudo.count, labels = labels,
        cell.clusters = cell.clusters, drop_thre = drop_thre, type = type,
        tr.length = tr.length, bulk = bulk, cores = cores, BPPARAM = BPPARAM,
        net.coef = net.coef, net.implementation = net.implementation, ...)

    # Run optimum choice
    choice <- ChooseMethod(real = round(train_data$train, 2),
            masked = round(train_data$mask, 2),
        imputed = train_imputed, write.to.file = write)

    return(ReturnChoice(sce, choice))
}


#' @title Dropout imputation using different methods
#'
#' @usage Impute(data, sce = NULL, do = 'Ensemble', write = FALSE,
#' outdir = getwd(), method.choice = NULL, scale = 1, pseudo.count = 1,
#' labels = NULL, cell.clusters = 2, drop_thre = NULL, type = 'count',
#' tr.length = ADImpute::transcript_length,
#' cores = BiocParallel::bpworkers(BPPARAM),
#' BPPARAM = BiocParallel::SnowParam(type = "SOCK"),
#' net.coef = ADImpute::network.coefficients, net.implementation = 'iteration',
#' bulk = NULL, true.zero.thr = NULL, prob.mat = NULL, ...)
#'
#' @description \code{Impute} performs dropout imputation on normalized data,
#' based on the choice of imputation methods.
#'
#' @param data matrix; raw counts (genes as rows and samples as columns)
#' @param sce SingleCellExperiment; normalized counts and associated metadata.
#' @param do character; choice of methods to be used for imputation. Currently
#' supported methods are \code{'Baseline'}, \code{'DrImpute'},
#' \code{'Network'}, and \code{'Ensemble'}. Defaults to \code{'Ensemble'}.
#' Not case-sensitive. Can include one or more methods. Non-supported methods
#' will be ignored.
#' @param write logical; write intermediary and imputed objects to files?
#' @param outdir character; path to directory where output files are written.
#' Defaults to working directory
#' @param method.choice character; best performing method in training data for
#' each gene
#' @param scale integer; scaling factor to divide all expression levels by
#' (defaults to 1)
#' @param pseudo.count integer; pseudo-count to be added to expression levels
#' to avoid log(0) (defaults to 1)
#' @param labels character; vector specifying the cell type of each column of
#' \code{data}
#' @param cell.clusters integer; number of cell subpopulations
#' @param drop_thre numeric; between 0 and 1 specifying the threshold to
#' determine dropout values
#' @param type A character specifying the type of values in the expression
#' matrix. Can be 'count' or 'TPM'
#' @param tr.length matrix with at least 2 columns: 'hgnc_symbol' and
#' 'transcript_length'
#' @param cores integer; number of cores used for paralell computation
#' @param BPPARAM parallel back-end to be used during parallel computation.
#' See \code{\link[BiocParallel]{BiocParallelParam-class}}.
#' @param net.coef matrix; network coefficients. Please provide if you don't
#' want to use ADImpute's network model. Must contain one first column 'O'
#' acconting for the intercept of the model and otherwise be an adjacency matrix
#' with hgnc_symbols in rows and columns. Doesn't have to be squared. See
#' \code{ADImpute::demo_net} for a small example.
#' @param net.implementation character; either 'iteration', for an iterative
#' solution, or 'pseudoinv', to use Moore-Penrose pseudo-inversion as a
#' solution. 'pseudoinv' is not advised for big data.
#' @param bulk vector of reference bulk RNA-seq, if available (average across
#' samples)
#' @param true.zero.thr if set to NULL (default), no true zero estimation is
#' performed. Set to numeric value between 0 and 1 for estimation. Value
#' corresponds to the threshold used to determine true zeros: if the probability
#' of dropout is lower than \code{true.zero.thr}, the imputed entries are set
#' to zero.
#' @param prob.mat matrix of the same size as data, filled with the dropout
#' probabilities for each gene in each cell
#' @param ... additional parameters to pass to network-based imputation
#'
#' @return
#' \itemize{
#'     \item if \code{sce} is not set: returns a list of imputation results
#'     (normalized, log-transformed) for all selected methods in \code{do}. If
#'     \code{true.zero.thr} is defined, returns a list of 3 elements: 1) a list,
#'     \code{imputations}, containing the direct imputation results from each
#'     method; 2) a list, \code{zerofiltered}, containing the results of
#'     imputation in \code{imputations} after setting biological zeros back to
#'     zero; 3) a matrix, \code{dropoutprobabilities}, containing the dropout
#'     probability matrix used to set biological zeros.
#'     \item if \code{sce} is set: returns a SingleCellExperiment with new
#'     assays, each corresponding to one of the imputation methods applied. If
#'     \code{true.zero.thr} is defined, the assays will contain the results
#'     after imputation and setting biological zeros back to zero.
#'}
#'
#' @details Values that are 0 in \code{data} are imputed according to the
#' best-performing methods indicated in \code{method.choice}. Currently
#' supported methods are:
#' \itemize{
#'     \item \code{Baseline}: imputation with average expression across all
#' cells in the dataset. See \code{\link{ImputeBaseline}}.
#'     \item Previously published approaches: \code{DrImpute} and \code{SAVER}.
#'     \item \code{Network}: leverages information from a gene regulatory
#' network to predicted expression of genes that are not quantified based on
#' quantified interacting genes, in the same cell. See
#' \code{\link{ImputeNetwork}}.
#'     \item \code{Ensemble}: is based on results on a training subset of the
#' data at hand, indicating which method best predicts the expression of
#' each gene. These results are supplied via \code{method.choice}. Applies
#' the imputation results of the best performing method to the zero entries
#' of each gene.
#' }
#' If \code{'Ensemble'} is included in \code{do}, \code{method.choice} has to
#' be provided (use output from \code{EvaluateMethods()}).
#' \code{Impute} can create a directory \code{imputation} containing the
#' imputation results of all methods in \code{do}.
#' If \code{true.zero.thr} is set, dropout probabilities are computed using
#' scImpute's framework. Expression values with dropout probabilities below
#' \code{true.zero.thr} will be set back to 0 if imputed, as they likely
#' correspond to true biological zeros (genes not expressed in cell) rather than
#' technical dropouts (genes expressed but not captured).
#' If \code{sce} is set, imputed values by the different methods are added as
#' new assays to \code{sce}. Each assay corresponds to one imputation method. If
#' \code{true.zero.thr} is set, only the values after filtering for biological
#' zeros will be added. This is different from the output if \code{sce} is not
#' set, where the original values before filtering and the dropout probability
#' matrix are returned.
#'
#' @examples
#' # Normalize demo data
#' norm_data <- NormalizeRPM(demo_data)
#' # Impute with particular method(s)
#' imputed_data <- Impute(do = 'Network', data = norm_data[,1:10],
#' net.coef = ADImpute::demo_net)
#' imputed_data <- Impute(do = 'Network', data = norm_data[,1:10],
#' net.implementation = 'pseudoinv', net.coef = ADImpute::demo_net)
#'
#' @seealso \code{\link{EvaluateMethods}},
#' \code{\link{ImputeBaseline}},
#' \code{\link{ImputeDrImpute}},
#' \code{\link{ImputeNetwork}},
#' \code{\link{ImputeSAVER}}
#'
#' @export
#'
Impute <- function(data, sce = NULL, do = "Ensemble", write = FALSE,
    outdir = getwd(), method.choice = NULL, scale = 1, pseudo.count = 1,
    labels = NULL, cell.clusters = 2, drop_thre = NULL, type = "count",
    tr.length = ADImpute::transcript_length, cores = BiocParallel::bpworkers(
        BPPARAM), BPPARAM = BiocParallel::SnowParam(type = "SOCK"), net.coef =
        ADImpute::network.coefficients, net.implementation = "iteration",
    bulk = NULL, true.zero.thr = NULL, prob.mat = NULL, ...) {

    # Check arguments
    if(!is.null(sce)){ DataCheck_SingleCellExperiment(sce)
        data <- SingleCellExperiment::normcounts(sce)
        method.choice <- stats::na.omit(
            SingleCellExperiment::int_elementMetadata(sce)$ADImpute$method) }
    check <- CreateArgCheck(missing = list(data = missing(data)),
        match = list(type = type), acceptable = list(type = c("TPM", "count")),
        null = list(net.coef = is.null(net.coef), data = is.null(data)))
    checkmate::reportAssertions(check)
    CheckArguments_Impute(data, method.choice, do, tr.length, labels,
        cell.clusters, true.zero.thr, drop_thre)
    data <- DataCheck_Matrix(data); tr.length <- DataCheck_TrLength(tr.length)
    if (write) { savedir <- getwd(); dir.create(paste0(outdir, "/imputation"))
        setwd(paste0(outdir, "/imputation")); on.exit(setwd(savedir)) }

    if ("ensemble" %in% tolower(do))
        do <- c(do, "Network", unique(method.choice))

    imputed <- list()
    if ("saver" %in% tolower(do)) {
        imputed$SAVER <- ImputeSAVER(data, cores, write = write)
        imputed$SAVER <- log2((imputed$SAVER/scale) + pseudo.count) }
    # Insert call to scImpute and SCRABBLE <-----
    log_masked_norm <- log2((data/scale) + pseudo.count)
    if ("baseline" %in% tolower(do))
        imputed$Baseline <- ImputeBaseline(log_masked_norm, write = write)
    if ("network" %in% tolower(do))
        imputed$Network <- ImputeNetwork(log_masked_norm, net.coef,
            type = net.implementation, cores, BPPARAM, write = write, ...)
    if ("drimpute" %in% tolower(do))
        imputed$DrImpute <- ImputeDrImpute(log_masked_norm, write = write)
    if ("ensemble" %in% tolower(do))
        imputed$Ensemble <- Combine(log_masked_norm, imputed, method.choice,
            write)

    # Estimate true zeros
    if (!is.null(true.zero.thr)) { results <- c(list(imputations = imputed),
            HandleBiologicalZeros(data, imputed, true.zero.thr, cell.clusters,
            labels, type, cores, BPPARAM, tr.length, prob.mat))
        return(ReturnOut(results, sce))
    } else { return(ReturnOut(imputed, sce)) }
}

methods <- EvaluateMethods(data = ADImpute::demo_data,
    net.coef = ADImpute::demo_net, cores = 2)

test_that("EvaluateMethods works with matrix input", {

    # output is a character vector
    expect_is(methods, "character")
    # entries are within appropriate methods
    expect_true(all(methods %in% c("Baseline","Network","DrImpute")))

    # test that it throws an appropriate error when no data
    expect_error(EvaluateMethods(data = NULL, net.coef = ADImpute::demo_net,
                                    cores = 2))
    # when no network coefficients
    expect_error(EvaluateMethods(data = ADImpute::demo_data, net.coef = NULL,
                                    cores = 2))
    # when no valid methods
    expect_error(EvaluateMethods(data = ADImpute::demo_data,
                    net.coef = ADImpute::demo_net, cores = 2, do = NULL))
    # when wrong methods are passed
    expect_error(EvaluateMethods(data = ADImpute::demo_data,
                    net.coef = ADImpute::demo_net, cores = 2, do = "wrong"),
                   paste0("Please provide at least one supported method"))
})

sce <- NormalizeRPM(sce = ADImpute::demo_sce)
sce <- EvaluateMethods(sce = sce, net.coef = ADImpute::demo_net, cores = 2)

test_that("EvaluateMethods works with SingleCellExperiment input", {

    # output is a character vector in the SingleCellExperiment
    expect_is(sce, "SingleCellExperiment")
    expect_is(SingleCellExperiment::int_elementMetadata(sce)$ADImpute$method,
        "character")
    # entries are within appropriate methods
    methods <- SingleCellExperiment::int_elementMetadata(sce)$ADImpute$method
    expect_true(all(stats::na.omit(methods) %in% c("Baseline","Network",
        "DrImpute")))

    # when no network coefficients
    expect_error(EvaluateMethods(sce = sce, net.coef = NULL, cores = 2))
    # when no valid methods
    expect_error(EvaluateMethods(sce = sce, net.coef = ADImpute::demo_net,
        cores = 2, do = NULL), "Please provide appropriate imputation methods")
    # when wrong methods are passed
    expect_error(EvaluateMethods(sce = sce, net.coef = ADImpute::demo_net,
        cores = 2, do = "wrong"),
        paste0("Please provide at least one supported method"))

})

imputation <- Impute(data = ADImpute::demo_data, method.choice = methods,
                     net.coef = ADImpute::network.coefficients, cores = 2)

test_that("Impute works with matrix input", {

    # output is a list
    expect_is(imputation, "list")
    # elements are matrices
    lapply(imputation, function(m) expect_is(m, "matrix"))

    # test that it throws an appropriate error when no data
    expect_error(Impute(data = NULL, net.coef = ADImpute::demo_net,
                        method.choice = methods, cores = 2))
    # when no network coefficients
    expect_error(Impute(data = ADImpute::demo_data, net.coef = NULL,
                        method.choice = methods, cores = 2))
    # when wrong methods are passed
    expect_error(Impute(data = ADImpute::demo_data,
                        net.coef = ADImpute::demo_net,
                        method.choice = methods, cores = 2, do = "wrong"),
                 "Please provide at least one supported method")
    expect_warning(Impute(data = ADImpute::demo_data,
                          net.coef = ADImpute::demo_net,
                          method.choice = methods, cores = 2, do = c("Baseline",
                                                                     "wrong")),
                   paste0("The following methods were detected as input but ",
                          "are not supported and will be ignored: 'wrong'"))
    # warning for SCRABBLE and scImpute
    expect_warning(tryCatch(Impute(data = ADImpute::demo_data,
                                   method.choice = methods,
                                   net.coef = ADImpute::network.coefficients,
                                   cores = 2, do = "scImpute")))
    expect_warning(tryCatch(Impute(data = ADImpute::demo_data,
                                   method.choice = methods,
                                   net.coef = ADImpute::network.coefficients,
                                   cores = 2, do = "SCRABBLE")))

})


imputation <- Impute(data = ADImpute::demo_data, do = "Baseline",
                     cores = 2, true.zero.thr = .3)

test_that("Impute works with biological zero determination", {

    # output is a list
    expect_is(imputation, "list")
    # elements are appropriate
    expect_is(imputation$imputations, "list")
    expect_is(imputation$zerofiltered, "list")
    expect_is(imputation$dropoutprobabilities, "matrix")

    # entries that are zero are less after setting biological zeros
    expect_true(sum(imputation$imputations$Baseline == 0) <
                    sum(imputation$zerofiltered$Baseline == 0))

    # works when providing labels
    expect_is(Impute(data = ADImpute::demo_data, do = "Baseline", cores = 2,
           labels = c(rep("A",20),rep("B",30)), true.zero.thr = .3), "list")
})

sce <- Impute(sce = sce, cores = 2)

test_that("Impute works with SingleCellExperiment input", {

    # output is a list
    expect_is(sce, "SingleCellExperiment")
    # elements are matrices
    lapply(SummarizedExperiment::assays(sce),
        function(m) expect_is(m, c("matrix", "dgCMatrix")))

    # when no network coefficients
    expect_error(Impute(sce = sce, net.coef = NULL, cores = 2))
    # when wrong methods are passed
    expect_error(Impute(sce = sce, net.coef = ADImpute::demo_net, cores = 2,
        do = "wrong"), "Please provide at least one supported method")
    expect_warning(Impute(sce = sce, net.coef = ADImpute::demo_net,
        cores = 2, do = c("Baseline", "wrong")),
        paste0("The following methods were detected as input but ",
            "are not supported and will be ignored: 'wrong'"))
    # warning for SCRABBLE and scImpute
    expect_warning(tryCatch(Impute(sce = sce, cores = 2, do = "scImpute",
        net.coef = ADImpute::network.coefficients)))
    expect_warning(tryCatch(Impute(sce = sce, cores = 2, do = "SCRABBLE",
        net.coef = ADImpute::network.coefficients)))

})

# ADImpute predicts unmeasured gene expression values from single cell
# RNA-sequencing data (dropout imputation). This R-package combines multiple
# dropout imputation methods, including a novel gene regulatory
# network-based method.  Copyright (C) 2020 Ana Carolina Leote This program
# is free software: you can redistribute it and/or modify it under the terms
# of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.  You should have received a copy of the
# GNU General Public License along with this program.  If not, see
# <https://www.gnu.org/licenses/>.


#' @title Data trimming
#'
#' @usage ArrangeData(data, net.coef = NULL)
#'
#' @description \code{ArrangeData} finds common genes to the network and
#' provided data and limits both datasets to these
#'
#' @param data matrix with entries equal to zero to be imputed (genes as rows
#' and samples as columns)
#' @param net.coef matrix; object containing network coefficients
#'
#' @return list; data matrix, network coefficients matrix and intercept for
#' genes common between the data matrix and the network
#'
ArrangeData <- function(data, net.coef = NULL) {

    if (is.null(data))
        stop("Please provide an input data matrix.\n")

    if (is.null(net.coef))
        stop("Please provide valid network coefficients.\n")

    data <- DataCheck_Matrix(data)
    net.coef <- DataCheck_Network(net.coef)

    O <- net.coef[, 1]  # network intercept
    network_matrix <- net.coef[, -1]  # network coefficients

    comm_targ <- intersect(rownames(network_matrix), rownames(data))
    comm_pred <- intersect(colnames(network_matrix), rownames(data))

    comm <- union(comm_targ, comm_pred)

    network_matrix <- round(network_matrix[comm_targ, comm_pred], 2)
    O <- round(O[comm_targ], 2)
    data <- data[comm, ]

    return(list(data = data, network = network_matrix, O = O))
}


#' @title Data centering
#'
#' @usage CenterData(data)
#'
#' @description \code{CenterData} centers expression of each gene at 0
#'
#' @param data matrix of gene expression to be centered row-wise (genes as rows
#' and samples as columns)
#'
#' @return list; row-wise centers and centered data
#'
CenterData <- function(data) {

    message("Centering expression of each gene at 0\n")


    center <- apply(data, 1, function(x) mean(x[x != 0], na.rm = TRUE))
    center[is.na(center)] <- 0
    center <- round(center, 2)

    names(center) <- rownames(data)

    data <- data - center

    return(list(center = center, data = data))
}


#' @title Network-based parallel imputation
#'
#' @usage ImputeNetParallel(drop.mat, arranged, cores =
#' BiocParallel::bpworkers(BPPARAM), type = 'iteration', max.iter = 50,
#' BPPARAM = BiocParallel::SnowParam(type = "SOCK"))
#' #'
#' @description \code{ImputeNetParallel} implements network-based imputation
#' in parallel
#'
#' @param drop.mat matrix, logical; dropout entries in the data matrix
#' (genes as rows and samples as columns)
#' @param arranged list; output of \code{\link{ArrangeData}}
#' @param cores integer; number of cores used for paralell computation
#' @param type character; either 'iteration', for an iterative solution, or
#' 'pseudoinv', to use Moore-Penrose pseudo-inversion as a solution.
#' @param max.iter numeric; maximum number of iterations for network
#' imputation. Set to -1 to remove limit (not recommended)
#' @param BPPARAM parallel back-end to be used during parallel computation.
#' See \code{\link[BiocParallel]{BiocParallelParam-class}}.
#'
#' @return matrix; imputation results incorporating network information
#'
ImputeNetParallel <- function(drop.mat, arranged,
    cores = BiocParallel::bpworkers(BPPARAM), type = "iteration", max.iter = 50,
    BPPARAM = BiocParallel::SnowParam(type = "SOCK")) {

    d <- intersect(rownames(drop.mat)[rowSums(drop.mat) != 0],
        rownames(arranged$network))  # dropouts in >= 1 cell
    p <- colnames(arranged$network)[Matrix::colSums(
        arranged$network[d, ]) != 0]  # all available predictors

    arranged$network <- arranged$network[d, p]

    if (type == "iteration") {
        message("Starting network iterative imputation\n")
        i <- 1
        repeat {
            if ((max.iter != -1) & (i > max.iter)) {
                break
            }
            if ((i%%5) == 0) {
                message(paste("Iteration", i, "/", max.iter, "\n"))
            }

            new <- round(arranged$network %*% arranged$centered[p, ], 2)
            # expression = network coefficients * predictor expr.

            # Check convergence
            if (any(new[drop.mat[d, ]] !=
                arranged$centered[d, ][drop.mat[d, ]])) {
                arranged$centered[d, ][drop.mat[d, ]] <- new[drop.mat[d, ]]
            } else {
                break
            }
            i <- i + 1
        }
        imp <- arranged$centered
    } else {
        arranged$network <- as.matrix(arranged$network)
        imp <- BiocParallel::bplapply(seq_len(ncol(arranged$centered)),
            function(i) { PseudoInverseSolution_percell(arranged$centered[, i],
                arranged$network, drop.mat[, i]) }, BPPARAM = BPPARAM)
        imp <- do.call(cbind, imp)
        colnames(imp) <- colnames(arranged$centered)
    }
    message("Network imputation complete\n")
    return(imp)
}


#' @title Helper function to PseudoInverseSolution_percell
#'
#' @usage ImputeNPDropouts(net, expr)
#'
#' @description \code{ImputeNPDropouts} computes the non-dropout-
#' dependent solution of network imputation for each cell
#'
#' @param net matrix, logical; network coefficients for all dropout (to be
#' imputed) genes that are predictive of the expression of other dropout genes
#' @param expr numeric; vector of gene expression for all genes in the cell at
#' hand
#'
#' @return vector; imputation results for the non-dropout-dependent genes
#'
ImputeNPDropouts <- function(net, expr) {

    if (!all(colnames(net) %in% names(expr)))
        stop("Not all predictors are included in the expression vector.\n")

    net <- net[, which(Matrix::colSums(net != 0) != 0)]
    solution <- net %*% expr[colnames(net)]

    return(solution)
}


#' @title Helper function to PseudoInverseSolution_percell
#'
#' @usage ImputePredictiveDropouts(net, thr = 0.01, expr)
#'
#' @description \code{ImputePredictiveDropouts} applies Moore-Penrose
#' pseudo-inversion to compute the dropout-dependent solution of network
#' imputation for each cell
#'
#' @param net matrix, logical; network coefficients for all dropout (to be
#' imputed) genes that are predictive of the expression of other dropout genes
#' @param thr numeric; tolerance threshold to detect zero singular values
#' @param expr numeric; vector of gene expression for all genes in the cell at
#' hand
#'
#' @return vector; imputation results for the dropout-dependent genes
#'
ImputePredictiveDropouts <- function(net, thr = 0.01, expr) {

    if (!all(colnames(net) %in% names(expr)))
        stop("Not all predictors are quantified in the expression vector.\n")

    # Y = inv(I - squared_A).C

    # dropouts that are predictors and targets
    squared_A <- net[rownames(net), rownames(net), drop = FALSE]

    # I - squared_A can be inverted
    message("Computing pseudoinverse\n")
    pinv <- MASS::ginv(diag(nrow(squared_A)) - as.matrix(squared_A), tol = thr)
    dimnames(pinv) <- dimnames(squared_A)
    rm(squared_A)
    gc()

    # find C (quantified predictors)
    message("Computing constant contribution C\n")
    net <- net[, !(colnames(net) %in% rownames(net)), drop = FALSE]
    net <- net[, Matrix::colSums(net != 0) != 0, drop = FALSE]
    C <- net %*% expr[colnames(net)]
    rm(net)
    gc()

    # Y = pinv.C
    solution <- pinv %*% C

    return(solution)
}


#' @title Network-based parallel imputation - Moore-Penrose pseudoinversion
#'
#' @usage PseudoInverseSolution_percell(expr, net, drop_ind, thr = 0.01)
#'
#' @description \code{PseudoInverseSolution_percell} applies Moore-Penrose
#' pseudo-inversion to compute the solution of network imputation for each
#' cell
#'
#' @param expr numeric; expression vector for cell at hand
#' @param net matrix; network coefficients
#' @param drop_ind logical; dropout entries in the cell at hand
#' @param thr numeric; tolerance threshold to detect zero singular values
#'
#' @return matrix; imputation results incorporating network information
#'
PseudoInverseSolution_percell <- function(expr, net, drop_ind, thr = 0.01) {

    message("Starting cell pseudo-inversion\n")

    # restrict network rows to the dropouts in the data
    net <- net[intersect(rownames(net), names(expr)[drop_ind]),
        intersect(colnames(net), names(expr))]

    # restrict to predictors that are predictive of the dropouts
    net <- net[, which(Matrix::colSums(net != 0) != 0)]

    # dropouts can themselves be predictors of other genes: Y_drop =
    # A_drop*Y_drop + A_quant*Y_quant the first term depends only on quantified
    # gene expression and known network coefficients, thus is constant; the
    # second term depends on itself as the dropout genes can themselves be
    # predictive of other genes

    # Dropout-based contribution (variable)
    pd <- intersect(rownames(net), colnames(net))
    pd_imputed <- ImputePredictiveDropouts(net[pd, , drop = FALSE], thr, expr)

    # Non-dropout-based contribution
    message("Adding remaining genes\n")
    npd <- names(expr)[drop_ind][!(names(expr)[drop_ind] %in%
        rownames(pd_imputed))]
    if (length(npd) > 0) {
        npd_imputed <- ImputeNPDropouts(net[intersect(npd, rownames(net)),
            , drop = FALSE], expr)
        full_solution <- rbind(pd_imputed, npd_imputed)  # join solutions
    } else {
        full_solution <- pd_imputed
    }

    final <- expr
    final[rownames(full_solution)] <- full_solution

    return(final)
}

testdata <- matrix(data = seq_len(25), nrow = 5, ncol = 5, byrow = TRUE,
                   dimnames = list(paste("Gene", seq_len(5)),
                                   paste("Cell", seq_len(5))))
testnet <- matrix(data = sample(rnorm(1000), 30), nrow = 5, ncol = 6,
                  dimnames = list(paste("Gene", c(1,2,3,6,7)),
                                  c("O", paste("Gene", c(1,3,4,7,8)))))


test_that("ArrangeData works", {

  # throws error when path to coefficients is not given
  expect_error(ArrangeData(testdata),
               "Please provide valid network coefficients.\n")
  # when path to coefficients is invalid

  # returns a list
  expect_is(ArrangeData(testdata, net.coef = testnet), "list")

  # returns the proper names and classes
  expect_equal(names(ArrangeData(testdata, net.coef = testnet)),
               c("data","network","O"))
  expect_is(ArrangeData(testdata, net.coef = testnet)$O,
            "numeric")
  expect_is(ArrangeData(testdata, net.coef = testnet)$network,
            "dgCMatrix")
  expect_is(ArrangeData(testdata, net.coef = testnet)$data,
            "matrix")

  arranged <- ArrangeData(testdata, net.coef = testnet)
  # length of intercept is the same as number of network targets
  expect_equal(length(arranged$O), nrow(arranged$network))

  # data is limited to genes that are predictors or targets
  expect_true(all(rownames(arranged$data) %in% c(rownames(arranged$network),
                                                 colnames(arranged$network))))
  # network is limited to genes present in data
  expect_true(all(union(rownames(arranged$network),
                        colnames(arranged$network)) %in%
                    rownames(arranged$data)))

  # all predictors in data are maintained
  expect_true(all(intersect(colnames(testnet),rownames(data)) %in%
                    colnames(arranged$network)))
  # all targets in data are maintained
  expect_true(all(intersect(rownames(testnet),rownames(data)) %in%
                    rownames(arranged$network)))

})

testdata1 <- testdata
testdata1[3,2] <- 0

test_that("CenterData works", {

  # returns a list of centered data and centers
  expect_is(CenterData(testdata), "list")
  expect_is(CenterData(testdata)$data, "matrix")
  expect_is(CenterData(testdata)$center, "numeric")

  # returns correct centered data and centers
  expect_equivalent(CenterData(testdata)$data, testdata - rowMeans(testdata))
  expect_equivalent(CenterData(testdata)$center, rowMeans(testdata))

  # handles zeros as instructed
  expect_equivalent(CenterData(testdata1)$center[3],
                    mean(testdata1[3,testdata1[3,] != 0]))
  expect_equivalent(CenterData(testdata1)$data[3,],
                    testdata1[3,] - mean(testdata1[3,testdata1[3,] != 0]))
  expect_equivalent(CenterData(testdata1)$center[-3],
                    rowMeans(testdata)[-3])
  expect_equivalent(CenterData(testdata1)$data[-3,],
                    CenterData(testdata)$data[-3,])
})

# ADImpute predicts unmeasured gene expression values from single cell
# RNA-sequencing data (dropout imputation). This R-package combines multiple
# dropout imputation methods, including a novel gene regulatory
# network-based method.  Copyright (C) 2020 Ana Carolina Leote This program
# is free software: you can redistribute it and/or modify it under the terms
# of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.  You should have received a copy of the
# GNU General Public License along with this program.  If not, see
# <https://www.gnu.org/licenses/>.


#' @title Data read
#'
#' @description \code{ReadData} reads data from raw input file (.txt or .csv)
#'
#' @usage ReadData(path, ...)
#'
#' @param path character; path to input file
#' @param ... additional arguments to \code{data.table::fread()}
#'
#' @return matrix; raw counts (genes as rows and samples as columns)
#'
ReadData <- function(path, ...) {

    # Read data
    if (grepl(path, pattern = ".txt")) {

        data <- data.frame(data.table::fread(file = path, header = TRUE,
            sep = "\t",  showProgress = TRUE, ...), row.names = 1)

        message("Data loaded\n")

    } else if (grepl(path, pattern = ".csv")) {

        data <- data.frame(data.table::fread(file = path, header = TRUE,
            sep = ",", showProgress = TRUE, ...), row.names = 1)

        message("Data loaded\n")

    } else {

        stop("Please input txt or csv file")
    }

    # Check for NAs - if yes convert to 0
    if (sum(is.na(data)) > 0) {

        data[is.na(data)] <- 0
        message("NAs converted to 0\n")
    }

    return(as.matrix(data))
}



#' @title Write txt file
#'
#' @description \code{WriteTXT} writes data to a tab-delimited output file
#'
#' @usage WriteTXT(object, file)
#'
#' @param object R object to write
#' @param file character; path to output file
#'
#' @return Returns NULL
#'
#' @examples
#' file <- tempfile()
#' WriteTXT(iris, file = file)
#'
#' @export
#'
WriteTXT <- function(object, file) {

    utils::write.table(object, file, quote = FALSE, sep = "\t")

    return(NULL)
}



#' @title Write csv file
#'
#' @description \code{WriteCSV} writes data to a comma-delimited output file
#'
#' @usage WriteCSV(object, file)
#'
#' @param object R object to write
#' @param file character; path to output file
#'
#' @return Returns NULL
#'
#' @examples
#' file <- tempfile()
#' WriteCSV(iris, file = file)
#'
#' @export
#'
WriteCSV <- function(object, file) {

    utils::write.csv(object, file)

    return(NULL)
}

test_that("WriteTXT works", {

  file <- tempfile()
  expect_false(file.exists(file))

  WriteTXT(iris, file)

  # Confirm file is written
  expect_true(file.exists(file))

  # Confirm file contents match expected
  expect_equivalent(iris, read.table(file, stringsAsFactors = TRUE))

  unlink(file)
})

test_that("WriteCSV works", {

  file <- tempfile()
  expect_false(file.exists(file))

  WriteCSV(iris, file)

  # Confirm file is written
  expect_true(file.exists(file))

  # Confirm file contents match expected
  expect_equivalent(iris, read.csv(file, stringsAsFactors = TRUE,
                                   row.names = 1))

  unlink(file)
})

# ADImpute predicts unmeasured gene expression values from single cell
# RNA-sequencing data (dropout imputation). This R-package combines multiple
# dropout imputation methods, including a novel gene regulatory
# network-based method.  Copyright (C) 2020 Ana Carolina Leote This program
# is free software: you can redistribute it and/or modify it under the terms
# of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.  You should have received a copy of the
# GNU General Public License along with this program.  If not, see
# <https://www.gnu.org/licenses/>.


#' @title Combine imputation methods
#'
#' @usage Combine(data, imputed, method.choice, write = FALSE)
#'
#' @param data matrix with entries equal to zero to be imputed, already
#' normalized (genes as rows and samples as columns)
#' @param method.choice named character; vector with the best performing method
#' per gene
#' @param imputed list; list of matrices with imputation results for all
#' considered methods
#' @param write logical; should a file with the imputation results be written?
#'
#' @details Combines imputation results from all methods according to training
#' results provided in \code{method.choice}
#'
#' @return matrix; imputation results combining the best performing method
#' per gene
#'
#'
Combine <- function(data, imputed, method.choice, write = FALSE) {

    message("Combining imputation results into ensemble\n")

    # all zeros are imputed
    dropouts <- data == 0

    best <- lapply(as.list(unique(method.choice)),
        function(m) names(method.choice)[method.choice == m])
    # some genes could not have a method assigned to them, because they were too
    # lowly expressed for any masking to be done. These are assigned to Network:
    best$Network <- c(best$Network, setdiff(rownames(data), unlist(best)))

    # combine imputations for best performing methods
    combined <- matrix(nrow = nrow(data), ncol = ncol(data),
        dimnames = dimnames(data))
    for (method in names(best))
        combined[best[[method]], ] <- imputed[[method]][best[[method]], ]
    combined <- DataCheck_Matrix(combined)

    # replace dropouts in the data with combined imputations
    imputed_combined <- data
    imputed_combined[dropouts] <- combined[dropouts]

    if (write)
        WriteTXT(imputed_combined, "final_imputation.txt")

    return(imputed_combined)
}


#' @title Impute using average expression across all cells
#'
#' @usage ImputeBaseline(data, write = FALSE, ...)
#'
#' @description \code{ImputeBaseline} imputes dropouts using gene averages
#' across cells. Zero values are excluded from the mean computation.
#'
#' @param data matrix with entries equal to zero to be imputed, normalized
#' and log2-transformed (genes as rows and samples as columns)
#' @param write logical; should a file with the imputation results be written?
#' @param ... additional arguments to \code{saveRDS}
#'
#' @return matrix; imputation results considering the average expression
#' values of genes
#'
ImputeBaseline <- function(data, write = FALSE, ...) {

    message("Imputing data using average expression\n")

    if (missing(data) | is.null(data))
        stop("Please provide an input data matrix\n")
    data <- as.matrix(data)

    dropouts <- data == 0

    # Compute mean expression levels across cells
    gene_avg <- apply(data, 1, function(x) mean(x[x != 0], na.rm = TRUE))
    gene_avg[is.na(gene_avg)] <- 0

    # Impute when dropout
    gene_avg_mat <- matrix(data = gene_avg, nrow = nrow(data),
                    ncol = ncol(data), byrow = FALSE, dimnames = dimnames(data))
    res <- data
    res[dropouts] <- gene_avg_mat[dropouts]

    if (write) {
        dir.create("Baseline")
        saveRDS(res, "Baseline/baseline_imputed.rds", ...)
    }

    return(res)
}



#' @title Use DrImpute
#'
#' @usage ImputeDrImpute(data, write = FALSE)
#'
#' @description \code{ImputeDrImpute} uses the DrImpute package for dropout
#' imputation
#'
#' @param data matrix with entries equal to zero to be imputed, normalized
#' and log2-transformed (genes as rows and samples as columns)
#' @param write logical; should a file with the imputation results be written?
#'
#' @return matrix; imputation results from DrImpute
#'
#' @seealso \code{\link[DrImpute]{DrImpute}}
#'
ImputeDrImpute <- function(data, write = FALSE) {

    message("Imputing data using DrImpute\n")

    if (missing(data) | is.null(data))
        stop("Please provide an input data matrix\n")
    data <- as.matrix(data)

    res <- DrImpute::DrImpute(as.matrix(data))
    colnames(res) <- colnames(data)

    if (write) {
        dir.create("DrImpute")
        saveRDS(res, "DrImpute/drimputed.rds")
    }

    return(res)
}


#' @title Network-based imputation
#'
#' @usage ImputeNetwork(data, net.coef = NULL,
#' cores = BiocParallel::bpworkers(BPPARAM),
#' BPPARAM = BiocParallel::SnowParam(type = "SOCK"),
#' type = 'iteration', write = FALSE, ...)
#'
#' @param data matrix with entries equal to zero to be imputed, normalized
#' and log2-transformed (genes as rows and samples as columns)
#' @param net.coef matrix; network coefficients.
#' @param cores integer; number of cores to use
#' @param BPPARAM parallel back-end to be used during parallel computation.
#' See \code{\link[BiocParallel]{BiocParallelParam-class}}.
#' @param type character; either 'iteration', for an iterative solution, or
#' 'pseudoinv', to use Moore-Penrose pseudo-inversion as a solution.
#' @param write logical; should a file with the imputation results be written?
#' @param ... additional arguments to \code{ImputeNetParallel}
#'
#' @details Imputes dropouts using a gene regulatory network trained on external
#' data, as provided in \code{net.coef}. Dropout expression values are
#' estimated from the expression of their predictor genes and the network
#' coefficients.
#'
#' @return matrix; imputation results incorporating network information
#'
#' @seealso \code{\link{ImputeNetParallel}}
#'
ImputeNetwork <- function(data, net.coef = NULL,
    cores = BiocParallel::bpworkers(BPPARAM),
    BPPARAM = BiocParallel::SnowParam(type = "SOCK"),
    type = "iteration", write = FALSE, ...) {

    message("Imputing data using network information\n")

    # Check arguments
    Check <- CreateArgCheck(match = list(type = type), acceptable =
                                list(type = c("iteration", "pseudoinv")))
    checkmate::reportAssertions(Check)

    # Limit data and network to genes common to both
    arranged <- ArrangeData(data, net.coef)

    message("Data dim:", paste(dim(arranged$data), collapse=" x "), "\n")
    message("Network dim:", paste(dim(arranged$network), collapse=" x "), "\n")

    # Center expression of each gene
    centered <- CenterData(arranged$data)
    arranged$centered <- as.matrix(centered$data)

    dropout_mat <- arranged$data == 0  # dropout indexes in the data matrix

    message("Calling network-based imputation\n")
    new_imp <- ImputeNetParallel(drop.mat = dropout_mat, arranged = arranged,
        cores = cores, type = type, BPPARAM = BPPARAM, ...)

    res <- data
    # add back gene means
    res[rownames(new_imp), ][dropout_mat[rownames(new_imp), ]] <-
        (centered$center[rownames(new_imp)] +
            new_imp)[dropout_mat[rownames(new_imp), ]]

    res[res < 0] <- 0

    if (write) {
        dir.create("Network")
        saveRDS(res, "Network/network_imputed.rds")
    }

    return(res)
}



#' @title Use SAVER
#'
#' @usage ImputeSAVER(data, cores, try.mean = FALSE, write = FALSE)
#'
#' @description \code{ImputeSAVER} uses the SAVER package for dropout
#' imputation
#'
#' @param data matrix with entries equal to zero to be imputed, normalized
#' (genes as rows and samples as columns)
#' @param cores integer; number of cores to use
#' @param try.mean logical; whether to additionally use mean gene expression
#' as prediction
#' @param write logical; should a file with the imputation results be written?
#'
#' @return matrix; imputation results from SAVER
#'
#' @seealso \code{\link[SAVER]{saver}}
#'
ImputeSAVER <- function(data, cores, try.mean = FALSE, write = FALSE) {

    message("Imputing data using SAVER\n")

    if (missing(data) | is.null(data))
        stop("Please provide an input data matrix.\n")
    data <- as.matrix(data)

    if (write)
        dir.create("SAVER")

    if (try.mean) {
        imp_mean <- SAVER::saver(data, size.factor = 1, ncores = cores,
        null.model = TRUE)
        if (write)
            saveRDS(object = imp_mean, file = "SAVER/SAVER_nullmodel.rds")
    }

    res <- SAVER::saver(data, size.factor = 1, ncores = cores,
        estimates.only = TRUE)

    if (write) {
        dir.create("SAVER")
        saveRDS(object = res, file = "SAVER/SAVER.rds")
    }

    return(res)
}

test_that("ImputeBaseline works", {

    out <- ImputeBaseline(data = ADImpute::demo_data)

    # test output is a matrix or dgCMatrix
    expect_is(out, c("matrix"))
    # test output dimensions are the same as in
    expect_equivalent(dim(ADImpute::demo_data), dim(out))

    # test that it throws an appropriate error when no data
    expect_error(ImputeBaseline(data = NULL),
                 "Please provide an input data matrix.")

    # test number of zeros decreases
    expect_true(sum(ADImpute::demo_data == 0) > sum(out == 0))
})


test_that("ImputeDrImpute works", {

    out <- ImputeDrImpute(data = ADImpute::demo_data)

    # test output is a matrix or dgCMatrix
    expect_is(out, c("matrix"))
    # test output dimensions are the same as in
    expect_equivalent(dim(ADImpute::demo_data), dim(out))

    # test that it throws an appropriate error when no data
    expect_error(ImputeDrImpute(data = NULL),
                 "Please provide an input data matrix.")

    # test number of zeros decreases
    expect_true(sum(ADImpute::demo_data == 0) > sum(out == 0))

})


test_that("ImputeNetwork works", {

    out <- ImputeNetwork(data = ADImpute::demo_data,
                         net.coef = ADImpute::demo_net, cores = 2)

    # test output is a matrix or dgCMatrix
    expect_is(out, c("matrix","dgCMatrix"))
    # test output dimensions are the same as in
    expect_equivalent(dim(ADImpute::demo_data), dim(out))

    # test that it throws an appropriate error when no data
    expect_error(ImputeNetwork(data = NULL, net.coef = ADImpute::demo_net,
                               cores = 2),
                 "Please provide an input data matrix.")
    # when no network coefficients
    expect_error(ImputeNetwork(data = ADImpute::demo_data, net.coef = NULL,
                               cores = 2),
                 "Please provide valid network coefficients.")

    # test number of zeros decreases
    expect_true(sum(ADImpute::demo_data == 0) >
                  sum(out == 0))
})

# Helper functions to ADImpute

#' @title Argument check
#'
#' @usage CreateArgCheck(missing = NULL, match = NULL, acceptable = NULL,
#' null = NULL)
#'
#' @description \code{CreateArgCheck} creates tests for argument correctness.
#'
#' @param missing named list; logical. Name corresponds to variable name, and
#' corresponding entry to whether it was missing from the function call.
#' @param match named list. Name corresponds to variable name, and corresponding
#' entry to its value.
#' @param acceptable named list. Name corresponds to variable name, and
#' corresponding entry to its acceptable values.
#' @param null named list; logical. Name corresponds to variable name, and
#' corresponding entry to whether it was NULL in the function call.
#'
#' @return argument check object.
#'
CreateArgCheck <- function(missing = NULL, match = NULL, acceptable = NULL,
    null = NULL) {

    coll <- checkmate::makeAssertCollection()

    # errors for missing arguments
    if (!is.null(missing)){
        for(varname in names(missing)){
            if (missing[[varname]]){
                coll$push(paste0("A value for ", varname,
                    " was not provided", sep = "'"))
            }
        }
    }

    # errors for arguments outside of predefined options
    if (!is.null(match) & !is.null(acceptable)){
        for (varname in names(match)) {
            checkmate::assert_subset(x = match[[varname]],
                choices = acceptable[[varname]],
                .var.name = varname,
                add = coll)
        }
    }

    # error for NULL arguments
    if (!is.null(null)){
        for (varname in names(null)) {
            if (null[[varname]]){
                coll$push(paste(NULL, varname, " must have a non-NULL value",
                                sep = "'"))
            }
        }
    }

    return(coll)
}


#' @title Argument check to Impute()
#'
#' @usage CheckArguments_Impute(data, method.choice, do, tr.length, labels,
#' cell.clusters, true.zero.thr, drop_thre)
#'
#' @param data matrix; raw counts (genes as rows and samples as columns)
#' @param method.choice character; best performing method in training data for
#' each gene
#' @param do character; choice of methods to be used for imputation. Currently
#' supported methods are \code{'Baseline'}, \code{'DrImpute'},
#' \code{'Network'}, and \code{'Ensemble'}. Defaults to \code{'Ensemble'}.
#' Not case-sensitive. Can include one or more methods. Non-supported methods
#' will be ignored.
#' @param tr.length matrix with at least 2 columns: 'hgnc_symbol' and
#' 'transcript_length'
#' @param labels character; vector specifying the cell type of each column of
#' \code{data}
#' @param cell.clusters integer; number of cell subpopulations
#' @param true.zero.thr if set to NULL (default), no true zero estimation is
#' performed. Set to numeric value between 0 and 1 for estimation. Value
#' corresponds to the threshold used to determine true zeros: if the probability
#' of dropout is lower than \code{true.zero.thr}, the imputed entries are set
#' to zero.
#' @param drop_thre numeric; between 0 and 1 specifying the threshold to
#' determine dropout values
#'
#' @description \code{CheckArguments_Impute} checks whether the arguments passed
#' to \code{Impute} are correct.
#'
#' @return NULL object
#'
CheckArguments_Impute <- function(data, method.choice, do, tr.length, labels,
    cell.clusters, true.zero.thr, drop_thre) {

    if (is.null(tr.length))
        tr.length <- ADImpute::transcript_length

    if (is.null(method.choice) & ("ensemble" %in% tolower(do)))
        stop(paste0("Please provide method.choice for Ensemble imputation. ",
            "Consider running EvaluateMethods()\n"))

    if (is.null(labels) & is.null(cell.clusters))
        stop(paste0("Please provide cell type labels ('labels') or number of",
            " cell clusters ('cell.clusters')\n"))

    if (is.null(do))
        stop("Please provide appropriate imputation methods\n")
    l <- tolower(do) %in% c("baseline", "drimpute", "ensemble", "network",
                            "saver", "scimpute", "scrabble")
    if (any(!l))
        warning(paste0("The following methods were detected as input but are",
            " not supported and will be ignored: ", paste(NULL, paste(do[!l],
                collapse = "', '"), NULL, sep = "'")))
    if ("scimpute" %in% tolower(do))
        warning(paste0("You are trying to run scImpute, which is not supported",
            " by default. Make sure you have installed scImpute from GitHub ",
            "and added the call to ImputescImpute() to the ADImpute code. ",
            "To add this call, move the code at Impute_extra.R#145 to ",
            "Wrap.R#270 and uncomment it.\n"))
    if ("scrabble" %in% tolower(do))
        warning(paste0("You are trying to run SCRABBLE, which is not supported",
            " by default. Make sure you have installed SCRABBLE from GitHub ",
            "and added the call to ImputeSCRABBLE() to the ADImpute code. ",
            "To add this call, move the code at Impute_extra.R#157 to ",
            "Wrap.R#270 and uncomment it.\n"))
    if (sum(l) == 0)
        stop("Please provide at least one supported method\n")

    if (!is.null(true.zero.thr)) {
        if ((true.zero.thr < 0) | (true.zero.thr > 1))
            stop("true.zero.thr must be a numeric between 0 and 1")
    }
    if (!is.null(drop_thre)) {
        if ((drop_thre < 0) | (drop_thre > 1))
            stop("drop_thre must be a numeric between 0 and 1")
    }

    return(NULL)
}


#' @title Data check (matrix)
#'
#' @usage DataCheck_Matrix(data)
#'
#' @description \code{DataCheck_Matrix} tests for potential format and storage
#' issues with matrices. Helper function to ADImpute.
#'
#' @param data data object to check
#'
#' @return data object with needed adjustments
#'
DataCheck_Matrix <- function(data) {

    # wrongly passed a SingleCellExperiment object
    if(class(data)[1] == "SingleCellExperiment"){
        stop(paste("SingleCellExperiment object passed as matrix. Please use",
            "argument 'sce' instead of 'data'.\n"))
    }

    # check format
    if (!is.matrix(data)) {
        message("Converting input to matrix.\n")
        data <- as.matrix(data)
    }

    # check if entries are numeric
    if (!is.numeric(data)) {
        stop("Input must be numeric.\n")
    }

    # check dimnames
    if (any(is.null(dimnames(data)))) {
        stop("Input has NULL dimnames.\n")
    }

    # look for NAs
    if (any(is.na(data))) {
        message("Converting NAs to zero.\n")
        if (all(is.na(data))) {
            stop("Input has only NAs.\n")
        }
        data[is.na(data)] <- 0
    }

    return(data)
}


#' @title Data check (network)
#'
#' @usage DataCheck_Network(network)
#'
#' @description \code{DataCheck_Network} tests for potential format and storage
#' issues with the network coefficient matrix. Helper function to ADImpute.
#'
#' @param network data object containing matrix coefficients
#'
#' @return network data object with needed adjustments
#'
DataCheck_Network <- function(network) {

    # 1st column is O
    if (colnames(network)[1] != "O")
        stop("First column of network matrix must be the intercept (O).\n")

    # is a matrix
    if (!methods::is(network, "sparseMatrix")) {
        message("Converting network to dgCMatrix.\n")
        network <- methods::as(network, "dgCMatrix")
    }

    # contents are not all 0
    if (!(any(network != 0)))
        stop("No non-zero coefficients in network matrix.\n")

    return(network)
}


#' @title Data check (SingleCellExperiment)
#'
#' @usage DataCheck_SingleCellExperiment(sce, normalized = TRUE)
#'
#' @description \code{DataCheck_SingleCellExperiment} tests for existence of the
#' appropriate assays in \code{sce}. Helper function to ADImpute.
#'
#' @param sce SingleCellExperiment; data for normalization or imputation
#' @param normalized logical; is the data expected to be normalized?
#'
#' @return NULL object.
#'
DataCheck_SingleCellExperiment <- function(sce, normalized = TRUE){

    if(normalized & (!("normcounts" %in%
        names(SummarizedExperiment::assays(sce))))){
        stop(paste("Normalized counts not found in 'normcounts' assay of",
            "SingleCellExperiment object.\n"))
    } else if((!normalized) & (!("counts" %in%
        names(SummarizedExperiment::assays(sce))))){
        stop(paste("Raw counts not found in 'counts' assay of",
            "SingleCellExperiment object.\n"))
    }

    return(NULL)
}


#' @title Data check (transcript length)
#'
#' @usage DataCheck_TrLength(trlength)
#'
#' @description \code{DataCheck_TrLength} tests for potential format and
#' storage issues with the object encoding transcript length, for e.g. TPM
#' normalization. Helper function to ADImpute.
#'
#' @param trlength data object containing transcript length information
#'
#' @return transcript length object with needed adjustments
#'
DataCheck_TrLength <- function(trlength) {

    # coerce to data.frame
    if (!is.data.frame(trlength)) {
        message("Converting input to data.frame.\n")
        trlength <- as.data.frame(trlength)
    }

    if (nrow(trlength) < 1)
        stop("Not enough rows in transcript length data.\n")

    # check if required colnames are present
    if (!all(c("hgnc_symbol", "transcript_length") %in% colnames(trlength)))
        stop(paste("Transcript length data must contain the following",
            "colnames: hgnc_symbol, transcript_length\n"))

    # check if columns have the right format
    if (!(is.factor(trlength$hgnc_symbol) | is.character(trlength$hgnc_symbol)))
        stop("hgnc_symbol column must be character/factor.\n")

    storage.mode(trlength$transcript_length) <- "numeric"

    # remove lines with '' hgnc_symbol
    hgnc_symbol <- NULL  # get rid of check note
    trlength <- subset(trlength, subset = hgnc_symbol != "")
    if (nrow(trlength) < 1)
        stop("Not enough non-empty gene symbols in transcript length data.\n")

    return(trlength)
}


#' @title Wrapper for return of EvaluateMethods()
#'
#' @usage ReturnChoice(sce, choice)
#'
#' @description \code{ReturnChoice} Adjusts the output of \code{EvaluateMethods}
#' to a character vector or a SingleCellExperiment object. Helper function to
#' ADImpute.
#'
#' @param sce SingleCellExperiment; a SingleCellExperiment object if available;
#' NULL otherwise
#' @param choice character; best performing method in the training set for each
#' gene
#'
#' @return
#'  \itemize{
#'     \item if \code{sce} is provided: returns a SingleCellExperiment with the
#'     best performing method per gene stored as row-features. Access via
#'     \code{SingleCellExperiment::int_elementMetadata(sce)$ADImpute$methods}.
#'     \item if \code{sce} is not provided: returns a character with the best
#'     performing method in the training set for each gene
#' }
#'
ReturnChoice <- function(sce, choice){
    if(is.null(sce)){
        message("Returning method choice vector.\n")
        return(choice)
    } else{
        message("Returning SingleCellExperiment object.\n")
        v <- rep(NA, nrow(sce))
        names(v) <- rownames(sce)
        v[names(choice)] <- choice
        SingleCellExperiment::int_elementMetadata(sce)$ADImpute <-
            S4Vectors::DataFrame(method = v)
        return(sce)
    }
}


#' @title Wrapper for return of Impute()
#'
#' @usage ReturnOut(result, sce)
#'
#' @description \code{ReturnOut} Adjusts the output of \code{Impute} to a list
#' of matrices or a SingleCellExperiment object. Helper function to ADImpute.
#'
#' @param result list; imputation result
#' @param sce SingleCellExperiment; a SingleCellExperiment object if available;
#' NULL otherwise
#'
#' @return imputation results. A SingleCellExperiment if \code{!is.null(sce)},
#' or a list with imputed results in matrix format otherwise.
#'
ReturnOut <- function(result, sce){

    if(is.null(sce)){
        message("Returning matrix lists.\n")
        return(result)
    } else{
        message("Returning SingleCellExperiment object.\n")
        if(length(result) == 0){
            return(sce)
        }
        if(!is.list(result[[1]])){
            SummarizedExperiment::assays(sce) <-
                c(SummarizedExperiment::assays(sce), result)
        } else{
            SummarizedExperiment::assays(sce) <-
                c(SummarizedExperiment::assays(sce), result$zerofiltered)
        }
        return(sce)
    }
}

testdata1 <- matrix(data = as.numeric(NA), nrow = 5, ncol = 5,
                    dimnames = list(paste("Gene", seq_len(5)),
                                    paste("Cell", seq_len(5))))
testdata2 <- matrix(data = seq_len(25), nrow = 5, ncol = 5, byrow = TRUE)
testdata3 <- matrix(data = seq_len(25), nrow = 5, ncol = 5, byrow = TRUE,
                    dimnames = list(paste("Gene", seq_len(5)),
                                    paste("Cell", seq_len(5))))
testdata4 <- testdata3
testdata4[3,2] <- NA
testdata5 <- testdata4
storage.mode(testdata5) <- "character"
testdata6 <- as.data.frame(testdata4)

output4 <- testdata4
output4[is.na(output4)] <- 0

test_that("DataCheck_Matrix works", {

  # Class of output is a matrix
  expect_is(DataCheck_Matrix(testdata3), "matrix")
  expect_is(DataCheck_Matrix(testdata4), "matrix")
  expect_is(DataCheck_Matrix(testdata6), "matrix")

  # Throws error when not numeric
  expect_error(DataCheck_Matrix(testdata5), "Input must be numeric.\n")
  # when no dimnames
  expect_error(DataCheck_Matrix(testdata2), "Input has NULL dimnames.\n")
  # when all NULL
  expect_error(DataCheck_Matrix(testdata1), "Input has only NAs.\n")

  # Converts NA to 0
  expect_equal(DataCheck_Matrix(testdata4), output4)
})


testtrlength1 <- unname(ADImpute::transcript_length)
testtrlength2 <- ADImpute::transcript_length[,2, drop = FALSE]
testtrlength3 <- ADImpute::transcript_length
testtrlength3$hgnc_symbol <- seq_len(nrow(testtrlength3))
testtrlength4 <- ADImpute::transcript_length
testtrlength4$hgnc_symbol <- rep("", nrow(testtrlength4))

test_that("DataCheck_TrLength works", {

  # Class of output is a data.frame
  expect_is(DataCheck_TrLength(ADImpute::transcript_length),"data.frame")
  expect_is(DataCheck_TrLength(as.matrix(ADImpute::transcript_length)),
            "data.frame")

  # Throws error when required colnames not present
  expect_error(DataCheck_TrLength(testtrlength1),
      paste("Transcript length data must contain the following colnames:",
          "hgnc_symbol, transcript_length\n"))
  expect_error(DataCheck_TrLength(testtrlength2),
      paste("Transcript length data must contain the following colnames:",
          "hgnc_symbol, transcript_length\n"))
  # when gene names are not character/factor
  expect_error(DataCheck_TrLength(testtrlength3),
      "hgnc_symbol column must be character/factor.\n")
  # when there are no rows
  expect_error(DataCheck_TrLength(testtrlength3[0,]),
      "Not enough rows in transcript length data.\n")
  # when all gene symbols are empty strings
  expect_error(DataCheck_TrLength(testtrlength4),
      "Not enough non-empty gene symbols in transcript length data.\n")

  # Converts character lengths to numeric
  expect_is(DataCheck_TrLength(as.matrix(
    ADImpute::transcript_length))$transcript_length, "numeric")

  # Removes empty gene symbols
  expect_false(any(as.character(DataCheck_TrLength(
    ADImpute::transcript_length)$hgnc_symbol) == ""))
})

# functions adapted from https://github.com/Vivianstats/scImpute version
# 0.0.9 see publication: https://www.nature.com/articles/s41467-018-03405-7

calculate_weight <- function(x, paramt) {
    pz1 <- paramt[1] * stats::dgamma(x, shape = paramt[2], rate = paramt[3])
    pz2 <- (1 - paramt[1]) * stats::dnorm(x, mean = paramt[4], sd = paramt[5])
    pz <- pz1/(pz1 + pz2)
    pz[pz1 == 0] <- 0
    return(cbind(pz, 1 - pz))
}


dmix <- function(x, pars) {
    pars[1] * stats::dgamma(x, shape = pars[2], rate = pars[3]) +
        (1 - pars[1]) * stats::dnorm(x, mean = pars[4], sd = pars[5])
}


find_hv_genes <- function(count, I, J) {
    count_nzero <- lapply(seq_len(I),
        function(i) setdiff(count[i, ], log10(1.01)))
    mu <- vapply(count_nzero, mean, FUN.VALUE = 1)
    mu[is.na(mu)] <- 0
    sd <- vapply(count_nzero, stats::sd, FUN.VALUE = 1)
    sd[is.na(sd)] <- 0
    cv <- sd/mu
    cv[is.na(cv)] <- 0
    high_var_genes <- which(mu >= 1 & cv >= stats::quantile(cv, 0.25))
    if (length(high_var_genes) < 500) {
        high_var_genes <- seq_len(I)
    }
    count_hv <- count[high_var_genes, ]
    return(count_hv)
}


find_neighbors_labeled <- function(count_hv, J, Kcluster = NULL, cores,
    BPPARAM, cell_labels = NULL) {
    if (is.character(cell_labels)) {
        labels_uniq <- unique(cell_labels); labels_mth <- seq_along(labels_uniq)
        names(labels_mth) <- labels_uniq; clust <- labels_mth[cell_labels]
    } else { clust <- cell_labels }
    nclust <- length(unique(clust)); message("calculating cell distances ...")
    dist_list <- lapply(seq_len(nclust), function(ll) {
        cell_inds <- which(clust == ll)
        count_hv_sub <- count_hv[, cell_inds, drop = FALSE]
        if (length(cell_inds) < 1000) {
            var_thre <- 0.4; pca <- stats::prcomp(t(count_hv_sub))
            eigs <- (pca$sdev)^2; var_cum <- cumsum(eigs)/sum(eigs)
            if (max(var_cum) <= var_thre) { npc <- length(var_cum)
            } else { npc <- which.max(var_cum > var_thre) }
        } else { var_thre <- 0.6
            pca <- rsvd::rpca(t(count_hv_sub), k = 1000, center = TRUE,
                scale = FALSE)
            eigs <- (pca$sdev)^2; var_cum <- cumsum(eigs)/sum(eigs)
            if (max(var_cum) <= var_thre) { npc <- length(var_cum)
            } else { npc <- which.max(var_cum > var_thre) }
        }
        if (npc < 3) { npc <- 3 }
        mat_pcs <- t(pca$x[, seq_len(npc)])
        dist_cells_list <- BiocParallel::bplapply(seq_along(cell_inds),
            function(id1) { d <- vapply(seq_len(id1), function(id2) {
                sse <- sum((mat_pcs[, id1] - mat_pcs[, id2])^2)
                sqrt(sse) }, FUN.VALUE = 1)
            return(c(d, rep(0, length(cell_inds) - id1))) }, BPPARAM = BPPARAM)
        dist_cells <- matrix(0, nrow = length(cell_inds),
            ncol = length(cell_inds))
        for (cellid in seq_along(cell_inds)) {
            dist_cells[cellid, ] <- dist_cells_list[[cellid]]
        }; dist_cells <- dist_cells + t(dist_cells)
        return(dist_cells)})
    return(list(dist_list = dist_list, clust = clust))
}


find_neighbors_unlabeled <- function(count_hv, J, Kcluster = NULL, cores,
    BPPARAM, cell_labels = NULL) {

    message("dimension reduction ...")
    if (J < 5000) { var_thre <- 0.4; pca <- stats::prcomp(t(count_hv))
        eigs <- (pca$sdev)^2; var_cum <- cumsum(eigs)/sum(eigs)
        if (max(var_cum) <= var_thre) { npc <- length(var_cum)
        } else {
            npc <- which.max(var_cum > var_thre); npc <- max(npc, Kcluster) }
    } else { var_thre <- 0.6
        pca <- rsvd::rpca(t(count_hv), k = 1000, center = TRUE, scale = FALSE)
        eigs <- (pca$sdev)^2; var_cum <- cumsum(eigs)/sum(eigs)
        if (max(var_cum) <= var_thre) { npc <- length(var_cum)
        } else {
            npc <- which.max(var_cum > var_thre); npc <- max(npc, Kcluster) }
    }; if (npc < 3) { npc <- 3 }
    mat_pcs <- t(pca$x[, seq_len(npc)])  # columns are cells
    message("calculating cell distances ...")
    dist_cells_list <- BiocParallel::bplapply(seq_len(J), function(id1) {
        d <- vapply(seq_len(id1), function(id2) {
            sse <- sum((mat_pcs[, id1] - mat_pcs[, id2])^2)
            sqrt(sse) }, FUN.VALUE = 1)
        return(c(d, rep(0, J - id1))) }, BPPARAM = BPPARAM)
    dist_cells <- matrix(0, nrow = J, ncol = J)
    for (cellid in seq_len(J)) {
        dist_cells[cellid, ] <- dist_cells_list[[cellid]] }
    dist_cells <- dist_cells + t(dist_cells)
    min_dist <- vapply(seq_len(J), function(i) { min(dist_cells[i, -i]) },
        FUN.VALUE = 1)
    iqr <- stats::quantile(min_dist, 0.75) - stats::quantile(min_dist, 0.25)
    outliers <- which(min_dist > 1.5 * iqr + stats::quantile(min_dist, 0.75))
    non_out <- setdiff(seq_len(J), outliers)
    spec_res <- kernlab::specc(t(mat_pcs[, non_out]), centers = Kcluster,
        kernel = "rbfdot")
    message("cluster sizes:"); message(spec_res@size)
    nbs <- rep(NA, J); nbs[non_out] <- spec_res
    return(list(dist_cells = dist_cells, clust = nbs))
}


find_va_genes <- function(parslist, subcount) {
    point <- log10(1.01)
    valid_genes <- which((rowSums(subcount) > point * ncol(subcount)) &
        stats::complete.cases(parslist))
    if (length(valid_genes) == 0)
        return(valid_genes)
    # find out genes that violate assumption
    mu <- parslist[, "mu"]
    sgene1 <- which(mu <= log10(1 + 1.01))

    dcheck1 <- stats::dgamma(mu + 1, shape = parslist[, "alpha"],
        rate = parslist[, "beta"])
    dcheck2 <- stats::dnorm(mu + 1, mean = parslist[, "mu"], sd = parslist[,
        "sigma"])
    sgene3 <- which(dcheck1 >= dcheck2 & mu <= 1)
    sgene <- union(sgene1, sgene3)
    valid_genes <- setdiff(valid_genes, sgene)
    return(valid_genes)
}

### root-finding equation
fn <- function(alpha, target) {
    log(alpha) - digamma(alpha) - target
}


### estimate parameters in the mixture distribution
get_mix <- function(xdata, point) {
    inits <- rep(0, 5)
    inits[1] <- sum(xdata == point)/length(xdata)
    if (inits[1] == 0) {
        inits[1] <- 0.01
    }
    inits[2:3] <- c(0.5, 1)
    xdata_rm <- xdata[xdata > point]
    inits[4:5] <- c(mean(xdata_rm), stats::sd(xdata_rm))
    if (is.na(inits[5])) {
        inits[5] <- 0
    }
    paramt <- inits
    eps <- 10
    iter <- 0
    loglik_old <- 0

    while (eps > 0.5) {
        wt <- calculate_weight(xdata, paramt)
        paramt[1] <- sum(wt[, 1])/nrow(wt)
        paramt[4] <- sum(wt[, 2] * xdata)/sum(wt[, 2])
        paramt[5] <- sqrt(sum(wt[, 2] * (xdata - paramt[4])^2)/sum(wt[, 2]))
        paramt[2:3] <- update_gmm_pars(x = xdata, wt = wt[, 1])

        loglik <- sum(log10(dmix(xdata, paramt)))
        eps <- (loglik - loglik_old)^2
        loglik_old <- loglik
        iter <- iter + 1
        if (iter > 100) {
            break
        }
    }
    return(paramt)
}

get_mix_parameters <- function(count, point = log10(1.01), path,
    cores, BPPARAM) {

    count <- as.matrix(count)
    null_genes <- which(abs(rowSums(count) - point * ncol(count)) < 1e-10)
    parslist <- BiocParallel::bplapply(seq_len(nrow(count)), function(ii) {
        if (ii%%2000 == 0) {
            gc()
            message(ii)
        }
        if (ii %in% null_genes) {
            return(rep(NA, 5))
        }
        xdata <- count[ii, ]
        paramt <- tryCatch(get_mix(xdata, point),
            error = function(e) rep(NA, 5))
        return(paramt)
    }, BPPARAM = BPPARAM)
    parslist <- Reduce(rbind, parslist)
    colnames(parslist) <- c("rate", "alpha", "beta", "mu", "sigma")
    return(parslist)
}


imputation_model8 <- function(count, labeled = FALSE, point, drop_thre = 0.5,
    Kcluster = 10, cores = BiocParallel::bpworkers(BPPARAM),
    BPPARAM = BiocParallel::SnowParam(type = "SOCK")) {

    count <- as.matrix(count); I <- nrow(count)
    J <- ncol(count); count_imp <- count; count_hv <- find_hv_genes(count, I, J)
    message("searching candidate neighbors ... ")
    if (Kcluster == 1) { clust <- rep(1, J)
        if (J < 5000) { var_thre <- 0.4; pca <- stats::prcomp(t(count_hv))
            eigs <- (pca$sdev)^2; var_cum <- cumsum(eigs)/sum(eigs)
            if (max(var_cum) <= var_thre) {  npc <- length(var_cum)
            } else { npc <- which.max(var_cum > var_thre)
                npc <- max(npc, Kcluster) }
        } else { var_thre <- 0.6
            pca <- rsvd::rpca(t(count_hv), k = 1000, center = TRUE,
                scale = FALSE)
            eigs <- (pca$sdev)^2; var_cum <- cumsum(eigs)/sum(eigs)
            if (max(var_cum) <= var_thre) { npc <- length(var_cum)
            } else {
                npc <- which.max(var_cum > var_thre); npc <- max(npc,Kcluster) }
        }
        if (npc < 3) { npc <- 3 }
        mat_pcs <- t(pca$x[, seq_len(npc)])  # columns are cells
        dist_cells_list <- BiocParallel::bplapply(seq_len(J), function(id1) {
            d <- vapply(seq_len(id1), function(id2) {
                sse <- sum((mat_pcs[, id1] - mat_pcs[, id2])^2)
                sqrt(sse) }, FUN.VALUE = 1); return(c(d, rep(0, J - id1))) },
            BPPARAM = BPPARAM)
        dist_cells <- matrix(0, nrow = J, ncol = J)
        for (cellid in seq_len(J)) {
            dist_cells[cellid, ] <- dist_cells_list[[cellid]] }
        dist_cells <- dist_cells + t(dist_cells)
    } else { message("inferring cell similarities ...")
        neighbors_res <- find_neighbors_unlabeled(count_hv = count_hv, J = J,
            Kcluster = Kcluster, cores = cores, BPPARAM = BPPARAM)
        dist_cells <- neighbors_res$dist_cells; clust <- neighbors_res$clust }
    return(MixtureModel(count, clust, cores, BPPARAM = BPPARAM, drop_thre))
}


imputation_wlabel_model8 <- function(count, labeled, cell_labels = NULL, point,
    drop_thre, Kcluster = NULL, cores = BiocParallel::bpworkers(BPPARAM),
    BPPARAM = BiocParallel::SnowParam(type = "SOCK")) {

    if (!(is.character(cell_labels) | is.numeric(cell_labels) |
        is.integer(cell_labels))) {
        stop("cell_labels should be a character or integer vector!")}

    count <- as.matrix(count); I <- nrow(count)
    J <- ncol(count); count_imp <- count
    count_hv <- find_hv_genes(count, I, J)
    message("searching candidate neighbors ... ")
    neighbors_res <- find_neighbors_labeled(count_hv = count_hv, J = J,
        cores = cores, BPPARAM = BPPARAM, cell_labels = cell_labels)
    dist_list <- neighbors_res$dist_list; clust <- neighbors_res$clust

    nclust <- sum(!is.na(unique(clust)))

    droprate <- list()
    for (cc in seq_len(nclust)) {
        message(paste("estimating dropout probability for type", cc, "..."))
        parslist <- get_mix_parameters(count = count[, which(clust == cc),
            drop = FALSE], point = log10(1.01), cores = cores,
            BPPARAM = BPPARAM)
        cells <- which(clust == cc); if (length(cells) <= 1) { next }
        message("searching for valid genes ...")
        valid_genes <- find_va_genes(parslist, subcount = count[, cells])
        if (length(valid_genes) <= 10) { next }

        subcount <- count[valid_genes, cells, drop = FALSE]
        Ic <- length(valid_genes); Jc <- ncol(subcount)
        parslist <- parslist[valid_genes, , drop = FALSE]

        droprate[[cc]] <- t(vapply(seq_len(Ic), function(i) {
            wt <- calculate_weight(subcount[i, ], parslist[i, ])
            return(wt[, 1]) }, FUN.VALUE = rep(1, Jc)))
        dimnames(droprate[[cc]]) <- dimnames(subcount)
        mucheck <- sweep(subcount, MARGIN = 1, parslist[, "mu"], FUN = ">")
        droprate[[cc]][mucheck & droprate[[cc]] > drop_thre] <- 0
    }

    dropratem <- matrix(data = NA, nrow = nrow(count), ncol = ncol(count),
        dimnames = dimnames(count))
    for (dmat in droprate) { dropratem[rownames(dmat), colnames(dmat)] <- dmat }

    return(dropratem)
}


MixtureModel <- function(count, clust, cores, BPPARAM, drop_thre) {

    nclust <- sum(!is.na(unique(clust)))

    droprate <- list()

    for (cc in seq_len(nclust)) {
        message(paste("estimating dropout probability for type", cc, "..."))
        parslist <- get_mix_parameters(count = count[, which(clust == cc),
            drop = FALSE], point = log10(1.01), cores = cores,
            BPPARAM = BPPARAM)
        cells <- which(clust == cc)
        if (length(cells) <= 1) {
            next
        }
        message("searching for valid genes ...")
        valid_genes <- find_va_genes(parslist, subcount = count[, cells])
        if (length(valid_genes) <= 10) {
            message("Not enough valid genes found ...")
            next
        }

        subcount <- count[valid_genes, cells, drop = FALSE]
        Ic <- length(valid_genes)
        Jc <- ncol(subcount)
        parslist <- parslist[valid_genes, , drop = FALSE]

        droprate[[cc]] <- t(vapply(seq_len(Ic), function(i) {
            wt <- calculate_weight(subcount[i, ], parslist[i, ])
            return(wt[, 1])
        }, FUN.VALUE = rep(1, Jc)))
        dimnames(droprate[[cc]]) <- dimnames(subcount)
        mucheck <- sweep(subcount, MARGIN = 1, parslist[, "mu"], FUN = ">")
        droprate[[cc]][mucheck & droprate[[cc]] > drop_thre] <- 0
    }

    dropratem <- matrix(data = NA, nrow = nrow(count), ncol = ncol(count),
        dimnames = dimnames(count))
    for (dmat in droprate) {
        dropratem[rownames(dmat), colnames(dmat)] <- dmat
    }

    return(dropratem)
}


read_count <- function(raw_count, type, genelen) {
    raw_count <- as.matrix(raw_count)
    message(paste("number of genes in raw count matrix", nrow(raw_count)))
    message(paste("number of cells in raw count matrix", ncol(raw_count)))

    if (type == "TPM") {
        if (length(genelen) != nrow(raw_count))
            stop("number of genes in 'genelen' and count matrix do not match! ")
        raw_count <- sweep(raw_count, 1, genelen, FUN = "*")
    }

    totalCounts_by_cell <- colSums(raw_count)
    totalCounts_by_cell[totalCounts_by_cell == 0] <- 1
    raw_count <- sweep(raw_count, MARGIN = 2, 10^6/totalCounts_by_cell,
        FUN = "*")
    if (min(raw_count) < 0) {
        stop("smallest read count cannot be negative!")
    }
    count_lnorm <- log10(raw_count + 1.01)
    return(count_lnorm)
}


### update parameters in gamma distribution
update_gmm_pars <- function(x, wt) {
    tp_s <- sum(wt)
    tp_t <- sum(wt * x)
    tp_u <- sum(wt * log(x))
    tp_v <- -tp_u/tp_s - log(tp_s/tp_t)
    if (tp_v <= 0) {
        alpha <- 20
    } else {
        alpha0 <- (3 - tp_v + sqrt((tp_v - 3)^2 + 24 * tp_v))/12/tp_v
        if (alpha0 >= 20) {
            alpha <- 20
        } else {
            alpha <- stats::uniroot(fn, c(0.9, 1.1) * alpha0, target = tp_v,
                extendInt = "yes")$root
        }
    }
    ## need to solve log(x) - digamma(x) = tp_v We use this approximation to
    ## compute the initial value
    beta <- tp_s/tp_t * alpha
    return(c(alpha, beta))
}

# ADImpute predicts unmeasured gene expression values from single cell
# RNA-sequencing data (dropout imputation). This R-package combines multiple
# dropout imputation methods, including a novel gene regulatory
# network-based method.  Copyright (C) 2020 Ana Carolina Leote This program
# is free software: you can redistribute it and/or modify it under the terms
# of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.  You should have received a copy of the
# GNU General Public License along with this program.  If not, see
# <https://www.gnu.org/licenses/>.

#' @title Get dropout probabilities
#'
#' @description \code{GetDropoutProbabilities} computes dropout probabilities
#' (probability of being a dropout that should be imputed rather than a true
#' biological zero) using an adaptation of scImpute's approach
#'
#' @usage GetDropoutProbabilities(data, thre, cell.clusters, labels = NULL,
#' type = 'count', cores, BPPARAM, genelen = ADImpute::transcript_length)
#'
#' @param data matrix; original data before imputation
#' @param thre numeric; probability threshold to classify entries as biological
#' zeros
#' @param cell.clusters integer; number of cell subpopulations
#' @param labels character; vector specifying the cell type of each column of
#' \code{data}
#' @param type A character specifying the type of values in the expression
#' matrix. Can be 'count' or 'TPM'
#' @param cores integer; number of cores used for paralell computation
#' @param BPPARAM parallel back-end to be used during parallel computation.
#' See \code{\link[BiocParallel]{BiocParallelParam-class}}.
#' @param genelen matrix with at least 2 columns: 'hgnc_symbol' and
#' 'transcript_length'
#'
#' @details This function follows scImpute's model to distinguish between
#' true biological zeros and dropouts, and is based on adapted code from the
#' scImpute R package.
#'
#' @return matrix with same dimensions as \code{data} containing the dropout
#' probabilities for the corresponding entries
#'
GetDropoutProbabilities <- function(data, thre, cell.clusters = 2,
    labels = NULL, type = "count", cores = BiocParallel::bpworkers(BPPARAM),
    BPPARAM = BiocParallel::SnowParam(type = "SOCK"),
    genelen = ADImpute::transcript_length) {

    labeled <- !is.null(labels)

    if (type == "TPM") {
        common <- intersect(rownames(data), genelen$hgnc_symbol)
        data <- data[common, ]
        genelen <- genelen[match(common, genelen$hgnc_symbol), ]
    }
    count_lnorm = read_count(raw_count = data, type = type, genelen = genelen)

    if (!labeled) {
        dropmat = imputation_model8(count = count_lnorm, labeled = labeled,
            point = log10(1.01), drop_thre = thre, Kcluster = cell.clusters,
            cores = cores, BPPARAM = BPPARAM)
    } else {
        dropmat = imputation_wlabel_model8(count = count_lnorm,
            labeled = labeled, cell_labels = labels, point = log10(1.01),
            drop_thre = thre, cores = cores, BPPARAM = BPPARAM,
            Kcluster = NULL)
    }
    return(dropmat)
}


#' @title Get dropout probabilities
#'
#' @description \code{GetDropoutProbabilities} computes dropout probabilities
#' (probability of being a dropout that should be imputed rather than a true
#' biological zero) using an adaptation of scImpute's approach
#'
#' @usage HandleBiologicalZeros(data, imputed, thre = 0.5, cell.clusters,
#' labels = NULL, type = 'count', cores = BiocParallel::bpworkers(BPPARAM),
#' BPPARAM = BiocParallel::SnowParam(type = "SOCK"),
#' genelen = ADImpute::transcript_length, prob.mat = NULL)
#'
#' @param data matrix; original data before imputation
#' @param imputed list; imputation results for considered methods
#' @param thre numeric; between 0 and 1 specifying the threshold to determine
#' dropout values
#' @param cell.clusters integer; number of cell subpopulations
#' @param labels character; vector specifying the cell type of each column of
#' \code{data}
#' @param type A character specifying the type of values in the expression
#' matrix. Can be 'count' or 'TPM'
#' @param cores integer; number of cores used for paralell computation
#' @param BPPARAM parallel back-end to be used during parallel computation.
#' See \code{\link[BiocParallel]{BiocParallelParam-class}}.
#' @param genelen matrix with at least 2 columns: 'hgnc_symbol' and
#' 'transcript_length'
#' @param prob.mat matrix with same dimensions as \code{data} containing the
#' dropout probabilities for the corresponding entries
#'
#' @details This function follows scImpute's model to distinguish between
#' true biological zeros and dropouts, and is based on adapted code from the
#' scImpute R package.
#'
#' @return list with 2 components: \code{zerofiltered}, a list equivalent to
#' \code{imputed} but with entries of imputed likely biological zeros set back
#' to zero, and \code{dropoutprobabilities}
#' matrix with same dimensions as \code{data} containing the dropout
#' probabilities for the corresponding entries
#'
HandleBiologicalZeros <- function(data, imputed, thre = 0.5, cell.clusters,
    labels = NULL, type = "count", cores = BiocParallel::bpworkers(BPPARAM),
    BPPARAM = BiocParallel::SnowParam(type = "SOCK"),
    genelen = ADImpute::transcript_length, prob.mat = NULL) {

    # the probability is not given - compute it
    if (is.null(prob.mat))
        prob.mat <- GetDropoutProbabilities(data = data, thre = thre,
            cell.clusters = cell.clusters, labels = labels, type = type,
            cores = cores, BPPARAM = BPPARAM, genelen = genelen)
    # use probability matrix
    zerofiltered <- BiocParallel::bplapply(imputed, SetBiologicalZeros,
        drop_probs = prob.mat, thre = thre, was_zero = data == 0,
        BPPARAM = BPPARAM)

    return(list(zerofiltered = zerofiltered, dropoutprobabilities = prob.mat))
}


#' @title Set biological zeros
#'
#' @description \code{SetBiologicalZeros} sets some of the entries back to zero
#' after dropout imputation, as they likely correspond to true biological zeros
#' (genes not expressed in given cell)
#'
#' @usage SetBiologicalZeros(imputation, drop_probs, thre = .2, was_zero)
#'
#' @param imputation matrix; imputed values
#' @param drop_probs matrix; dropout probabilities for each entry in
#' \code{imputation}. 0 means certain biological zero, while 1 means certain
#' dropout to be imputed
#' @param thre numeric; probability threshold to classify entries as biological
#' zeros
#' @param was_zero matrix; logical matrix: was the corresponding entry of
#' \code{imputation} originally a zero?
#'
#' @details Entries which were originally zero and have dropout probability
#' below \code{thre} are considered biological zeros and, if they were imputed,
#' are set back to 0.
#'
#' @return matrix containing likely biological zeros set back to 0.
#'
SetBiologicalZeros <- function(imputation, drop_probs, thre = 0.2, was_zero) {

    if (!all.equal(dim(imputation), dim(drop_probs))) {
        # limit both to the set of common genes / cells
        common_genes <- intersect(rownames(imputation), rownames(drop_probs))
        common_cells <- intersect(colnames(imputation), colnames(drop_probs))
        imputation <- imputation[common_genes, common_cells]
        drop_probs <- drop_probs[common_genes, common_cells]
    }

    # do not impute entries with NA probability (give prob = 0)
    drop_probs[is.na(drop_probs)] <- 0

    # set prob < threshold to zero
    set_to_zero <- drop_probs < thre
    imputed_entries <- was_zero & (imputation != 0)  # limit to imputed values
    imputation[set_to_zero & imputed_entries] <- 0

    return(imputation)
}

test_that("GetDropoutProbabilities works", {

  res <- GetDropoutProbabilities(data = ADImpute::demo_data, thre = .2,
    cores = 2, cell.clusters = 2)
  expect_is(res, "matrix")
  expect_true(all(na.omit(res) >= 0) & all(na.omit(res) <= 1))

  # handling only one cell cluster
  res <- GetDropoutProbabilities(data = ADImpute::demo_data, thre = .2,
    cores = 2, cell.clusters = 1)
  expect_is(res, "matrix")
  expect_true(all(na.omit(res) >= 0) & all(na.omit(res) <= 1))

  # handling labels
  res <- GetDropoutProbabilities(data = ADImpute::demo_data, thre = .2, cores =
    2, labels = c(rep("A",25), rep("B",25)))
  expect_is(res, "matrix")
  expect_true(all(na.omit(res) >= 0) & all(na.omit(res) <= 1))
})

# ADImpute predicts unmeasured gene expression values from single cell
# RNA-sequencing data (dropout imputation). This R-package combines multiple
# dropout imputation methods, including a novel gene regulatory
# network-based method.  Copyright (C) 2020 Ana Carolina Leote This program
# is free software: you can redistribute it and/or modify it under the terms
# of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.  You should have received a copy of the
# GNU General Public License along with this program.  If not, see
# <https://www.gnu.org/licenses/>.


#' @title RPM normalization
#'
#' @description \code{NormalizeRPM} performs RPM normalization, with possibility
#' to log the result
#'
#' @usage NormalizeRPM(data, sce = NULL, log = FALSE, scale = 1,
#' pseudo.count = 1)
#'
#' @param data matrix; raw data (genes as rows and samples as columns)
#' @param sce SingleCellExperiment; raw data
#' @param log logical; log RPMs?
#' @param scale integer; scale factor to divide RPMs by
#' @param pseudo.count numeric; if \code{log = TRUE}, value to add to RPMs in
#' order to avoid taking \code{log(0)}
#'
#' @return matrix; library size normalized data
#'
#' @examples
#' demo <- NormalizeRPM(ADImpute::demo_data)
#'
#' @export
#'
NormalizeRPM <- function(data, sce = NULL, log = FALSE, scale = 1,
    pseudo.count = 1) {

    if(!is.null(sce)){
        DataCheck_SingleCellExperiment(sce, normalized = FALSE)
        data <- SingleCellExperiment::counts(sce)
    }

    # check input data
    data <- DataCheck_Matrix(data)

    # divide by million RPK in sample - transcripts per million (TPM)
    data <- sweep(data, 2, STATS = colSums(data)/(10^6), FUN = "/")

    if(!is.null(sce))
        SingleCellExperiment::cpm(sce) <- data

    data <- data/scale

    if(!is.null(sce))
        SingleCellExperiment::normcounts(sce) <- data

    if (log) {
        if (pseudo.count == 0) {
            warning("Using 0 pseudocount: Inf may be generated.\n")
        }
        data <- log2(data + pseudo.count)

        if(!is.null(sce))
            SingleCellExperiment::logcounts(sce) <- data
    }

    if(is.null(sce)){
        return(data)
    } else{
        return(sce)
    }
}


#' @title TPM normalization
#'
#' @description \code{NormalizeTPM} performs TPM normalization, with possibility
#' to log the result
#'
#' @usage NormalizeTPM(data, sce = NULL, tr_length = NULL, log = FALSE,
#' scale = 1, pseudo.count = 1)
#'
#' @param data matrix; raw data (genes as rows and samples as columns)
#' @param sce SingleCellExperiment; raw data
#' @param tr_length data.frame with at least 2 columns: 'hgnc_symbol'
#' and 'transcript_length'
#' @param log logical; log TPMs?
#' @param scale integer; scale factor to divide TPMs by
#' @param pseudo.count numeric; if \code{log = T}, value to add to TPMs in order
#' to avoid taking \code{log(0)}
#'
#' @details Gene length is estimated as the median of the lengths of all
#' transcripts for each gene, as obtained from biomaRt.
#' Genes for which length information cannot be found in biomaRt are dropped.
#'
#' @return matrix; normalized data (for transcript length and library size)
#'
#' @examples
#' demo <- NormalizeTPM(ADImpute::demo_data)
#'
#' @export
#'
NormalizeTPM <- function(data, sce = NULL, tr_length = NULL, log = FALSE,
    scale = 1, pseudo.count = 1) {

    if (is.null(tr_length))
        tr_length <- ADImpute::transcript_length

    tr_length <- DataCheck_TrLength(tr_length)

    if(!is.null(sce)){
        DataCheck_SingleCellExperiment(sce, normalized = FALSE)
        data <- SingleCellExperiment::counts(sce)
    }

    # check input data
    data <- DataCheck_Matrix(data)

    # Median length of all transcripts for a given gene
    med_length <- stats::aggregate(x = tr_length$transcript_length,
        by = list(hgnc_symbol = tr_length$hgnc_symbol), FUN = stats::median)
    common <- intersect(rownames(data), med_length$hgnc_symbol)
    if (length(common) < 2)
        stop("No enough overlap between data rownames and transcript length.\n")
    data <- data[common, ]

    med_length <- med_length[match(common, med_length$hgnc_symbol), ]

    # divide by length of transcript in kb - reads per kilobase (RPK)
    data <- sweep(data, 1, STATS = med_length$x/1000, FUN = "/")
    # divide by million RPK in sample - transcripts per million (TPM)
    data <- sweep(data, 2, STATS = colSums(data)/(10^6), FUN = "/")

    if(!is.null(sce))
        SingleCellExperiment::tpm(sce) <- data

    data <- data/scale

    if(!is.null(sce))
        SingleCellExperiment::normcounts(sce) <- data

    if (log) {
        if (pseudo.count == 0)
            warning("Using 0 pseudocount: Inf may be generated.\n")
        data <- log2(data + pseudo.count)
        if(!is.null(sce))
            SingleCellExperiment::logcounts(sce) <- data
    }

    if(is.null(sce)){ return(data) } else{ return(sce) }
}

testdata <- matrix(data = seq_len(25), nrow = 5, ncol = 5, byrow = TRUE,
                   dimnames = list(paste("Gene", seq_len(5)),
                                   paste("Cell", seq_len(5))))
testdata[3,2] <- NA

test_that("NormalizeRPM works with matrix input", {

  # All colSums are 1M
  expect_equivalent(colSums(NormalizeRPM(testdata)), rep(10^6, ncol(testdata)))

  # Class of output is a matrix
  expect_is(NormalizeRPM(testdata), "matrix")

  # Log works
  expect_equal(NormalizeRPM(testdata, log = TRUE),
               log2(1+NormalizeRPM(testdata)))

  # Log with no pseudocount throws warning
  expect_warning(NormalizeRPM(testdata, log = TRUE, pseudo.count = 0),
                 "Using 0 pseudocount: Inf may be generated.\n")

  # Scale works
  expect_equal(NormalizeRPM(testdata, scale = 100),
               NormalizeRPM(testdata)/100)
})


sce <- SingleCellExperiment::SingleCellExperiment(list(counts = testdata))

test_that("NormalizeRPM works with SingleCellExperiment input", {

  # The correct slots are created
  expect_true(all(c("cpm","normcounts") %in%
      names(SummarizedExperiment::assays(NormalizeRPM(sce = sce)))))
  expect_equal(SingleCellExperiment::cpm(NormalizeRPM(sce = sce)),
      SingleCellExperiment::normcounts(NormalizeRPM(sce = sce)))

  # All colSums are 1M
  expect_equivalent(colSums(SingleCellExperiment::cpm(NormalizeRPM(sce = sce))),
      rep(10^6, ncol(sce)))

  # Class of output is a SingleCellExperiment
  expect_is(NormalizeRPM(sce = sce), "SingleCellExperiment")

  # Log works
  expect_equal(SingleCellExperiment::logcounts(NormalizeRPM(sce = sce,
      log = TRUE)), log2(1+SingleCellExperiment::cpm(NormalizeRPM(sce = sce))))
  expect_equal(SingleCellExperiment::logcounts(NormalizeRPM(sce = sce,
      log = TRUE)), log2(1+SingleCellExperiment::cpm(NormalizeRPM(sce = sce,
      log = TRUE))))

  # Log with no pseudocount throws warning
  expect_warning(NormalizeRPM(sce = sce, log = TRUE, pseudo.count = 0),
                 "Using 0 pseudocount: Inf may be generated.\n")

  # Scale works
  expect_equal(SingleCellExperiment::normcounts(NormalizeRPM(sce = sce,
      scale = 100)),
      SingleCellExperiment::normcounts(NormalizeRPM(sce = sce))/100)
  expect_equal(SingleCellExperiment::normcounts(NormalizeRPM(sce = sce,
      scale = 100)),
      SingleCellExperiment::cpm(NormalizeRPM(sce = sce, scale = 100))/100)

})

rownames(testdata) <- sample(levels(ADImpute::transcript_length$hgnc_symbol),
                             nrow(testdata))
testtrlength <- data.frame("hgnc_symbol" = rownames(testdata),
                           "transcript_length" = rep(2,nrow(testdata)))
testoutput <- testdata[,1]/2
testoutput <- testoutput*1000000/sum(testoutput)

test_that("NormalizeTPM works with matrix input",{

  # Class of output is a matrix
  expect_is(NormalizeTPM(testdata), "matrix")

  # Log works
  expect_equal(NormalizeTPM(testdata, log = TRUE),
               log2(1+NormalizeTPM(testdata)))

  # Log with no pseudocount throws warning
  expect_warning(NormalizeTPM(testdata, log = TRUE, pseudo.count = 0),
                 "Using 0 pseudocount: Inf may be generated.\n")

  # Scale works
  expect_equal(NormalizeTPM(testdata, scale = 100),
               NormalizeTPM(testdata)/100)

  # Providing own gene length works
  expect_equal(NormalizeTPM(testdata, tr_length = testtrlength)[,1],
               testoutput)
})

sce <- SingleCellExperiment::SingleCellExperiment(list(counts = testdata))

test_that("NormalizeTPM works with SingleCellExperiment input",{

  # The correct slots are created
  expect_true(all(c("tpm","normcounts") %in%
      names(SummarizedExperiment::assays(NormalizeTPM(sce = sce)))))
  expect_equal(SingleCellExperiment::tpm(NormalizeTPM(sce = sce)),
      SingleCellExperiment::normcounts(NormalizeTPM(sce = sce)))

  # Class of output is a SingleCellExperiment
  expect_is(NormalizeTPM(sce = sce), "SingleCellExperiment")

  # Log works
  expect_equal(SingleCellExperiment::logcounts(NormalizeTPM(sce = sce,
      log = TRUE)),
      log2(1+SingleCellExperiment::normcounts(NormalizeTPM(sce = sce))))
  expect_equal(SingleCellExperiment::logcounts(NormalizeTPM(sce = sce,
      log = TRUE)), log2(1+
      SingleCellExperiment::normcounts(NormalizeTPM(sce = sce, log = TRUE))))

  # Log with no pseudocount throws warning
  expect_warning(NormalizeTPM(sce = sce, log = TRUE, pseudo.count = 0),
      "Using 0 pseudocount: Inf may be generated.\n")

  # Scale works
  expect_equal(SingleCellExperiment::normcounts(NormalizeTPM(sce = sce,
      scale = 100)),
      SingleCellExperiment::normcounts(NormalizeTPM(sce = sce))/100)
  expect_equal(SingleCellExperiment::normcounts(NormalizeTPM(sce = sce,
      scale = 100)),
      SingleCellExperiment::tpm(NormalizeTPM(sce = sce, scale = 100))/100)

  # Providing own gene length works
  expect_equal(SingleCellExperiment::normcounts(NormalizeTPM(sce = sce,
      tr_length = testtrlength))[,1], testoutput)
})

#' @title Small dataset for example purposes
#'
#' @description A small dataset to use on vignettes and examples (50 cells).
#'
#' @format matrix; a subset of the Grun pancreas dataset, obtained with the
#' \code{scRNAseq} R package, to use in the vignette and examples.
#'
#' @references Grun D et al. (2016). De novo prediction of stem cell identity
#' using single-cell transcriptome data. Cell Stem Cell 19(2), 266-277.
#'
"demo_data"

#' @title Small dataset for example purposes
#'
#' @description A small dataset to use on vignettes and examples (50 cells).
#'
#' @format SingleCellExperiment; a subset of the Grun pancreas dataset, obtained
#' with the \code{scRNAseq} R package, to use in the vignette and examples.
#'
#' @references Grun D et al. (2016). De novo prediction of stem cell identity
#' using single-cell transcriptome data. Cell Stem Cell 19(2), 266-277.
#'
"demo_sce"

#' @title Small regulatory network for example purposes
#'
#' @description Subset of the Gene Regulatory Network used by ADImpute's Network
#' imputation method.
#'
#' @format matrix; subset of the Gene Regulatory Network installed along with
#' ADImpute.
#'
"demo_net"

#' @title Transcriptome wide gene regulatory network
#'
#' @description Gene Regulatory Network used by ADImpute's Network imputation
#' method. First column, \code{O}, corresponds to the intercept of a gene-
#' -specific predicion model. The remaining rows and columns correspond to the
#' adjacency matrix of the inferred network, where rows are target genes and
#' columns are predictors. Genes are identified by their hgnc_symbol.
#'
#' @format dgCMatrix
#'
"network.coefficients"

#' @title Table for transcript length calculations
#'
#' @description A data.frame to be used for transcript length computations.
#' May be necessary upon TPM normalization, or as input to \code{scImpute}.
#' All data was retrieved from \code{biomaRt}.
#'
#' @format A data.frame with 2 columns:
#' \describe{
#' \item{hgnc_symbol}{Gene symbol identifier}
#' \item{transcript length}{Length of transcript}
#' }
#'
"transcript_length"

---
title: "ADImpute tutorial"
package: ADImpute
output: BiocStyle::html_document
vignette: >
    %\VignetteIndexEntry{ADImpute tutorial}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
is_check <- ("CheckExEnv" %in% search()) || any(c("_R_CHECK_TIMINGS_",
    "_R_CHECK_LICENSE_") %in% names(Sys.getenv()))
knitr::opts_chunk$set(eval = !is_check, collapse = TRUE, comment = "#>")
library(ADImpute)
```

# Introduction
ADImpute predicts unmeasured gene expression values from single cell
RNA-sequencing data (dropout imputation). This R-package combines multiple
dropout imputation methods. ADImpute currently supports, by default,
\code{DrImpute} and \code{SAVER} and two novel imputation methods:
\code{Baseline} and \code{Network}. \code{Baseline} imputes dropouts with the
average quantified expression level of the respective gene across the dataset.
\code{Network} uses previously learnt regulatory models of gene expression to
infer the expression of dropout genes from the expression of other relevant
(predictive) genes in the cell.
ADImpute consists of 2 fundamental functions: \code{EvaluateMethods()} and
\code{Impute()}.

# Imputation with method(s) of choice
The \code{Impute()} function allows for dropout imputation with one or more of
the supported methods. In order to specify which imputation method(s) to run,
pass them via the \code{do} argument:
```{r, warning=FALSE, message=FALSE, eval=FALSE}
RPM <- NormalizeRPM(ADImpute::demo_data)
imputed <- Impute(data = RPM, do = c("Network"), cores = 2,
    net.coef = ADImpute::demo_net)
```

# Imputation with ensemble
In addition to running different methods on the data, ADImpute can also
determine which of these performs best for each gene and perform an "Ensemble"
imputation, which combines the best performing methods for different genes.
First, evaluate methods using \code{EvaluateMethods} to determine the best
performing imputation method for each gene. This step sets a fraction of the
quantified entries in the input data to zero, applies different imputation
methods to the data and compares the imputation results to the original values.
This allows ADImpute to determine which method imputes values with the lowest
errors for each gene.
```{r, warning=FALSE, message=FALSE, results=FALSE}
RPM <- NormalizeRPM(ADImpute::demo_data)
methods_pergene <- EvaluateMethods(data = RPM,
    do = c("Baseline", "DrImpute", "Network"),
    cores = 2, net.coef = ADImpute::demo_net)
```

```{r, warning=FALSE}
head(methods_pergene)
```
After determining which method performs best for each gene, the imputation can
be re-done on the original data and the results of different methods combined
into an ensemble:
```{r, warning=FALSE, message=FALSE, results=FALSE}
imputed <- Impute(do = "Ensemble", method.choice = methods_pergene,
    data = RPM, cores = 2, net.coef = ADImpute::demo_net)
```

```{r, warning=FALSE}
str(imputed)
```
Both the method-specific imputations and the final ensemble results are
available for further examination.

# Determination of biological zeros
Some zeros in the data correspond to genes expressed in the cell, but not
captured upon sequencing - the technical dropouts - while others correspond to
genes truly not expressed in the cell - the biological zeros. In order to avoid
imputation of biological zeros, \code{ADImpute} adapts the well-established
approach of \code{scImpute} for the computation of the probability of each entry
to be a technical dropout. A matrix of such probabilities, of the same size as
the original data, can be provided by the user, or computed by \code{ADImpute}
using \code{scImpute}'s approach, as below. To activate this option, provide a
value for \code{true.zero.thr} in the call to \code{Impute()}, as exemplified
below:
```{r, warning=FALSE, message=FALSE, results=FALSE}
imputed <- Impute(do = "Baseline",
    data = RPM,
    cores = 2,
    true.zero.thr = .3)
```

```{r, warning=FALSE}
str(imputed)
```

# Imputation of a SingleCellExperiment
\code{ADImpute} can also take a \code{SingleCellExperiment} object as input.
In this case, \code{EvaluateMethods()} will result in new internal row metadata
being added to the \code{SingleCellExperiment} object, with the best performing
methods per gene. \code{Impute()} results in new assays being added to the
object. If \code{true.zero.thr} is specified, only the results after setting
biological zeros back to zero will be added to the \code{SingleCellExperiment}
object.
```{r, warning=FALSE, message=FALSE, results=FALSE}
sce <- NormalizeRPM(sce = ADImpute::demo_sce)
sce <- EvaluateMethods(sce = sce)
sce <- Impute(sce = sce)
```

# Additional imputation methods
\code{ADImpute} is built in a modular way, which facilitates the addition of
custom functions supporting other imputation methods. Two such methods are
\code{scImpute} and \code{SCRABBLE}, with wrapper functions already contained
within \code{ADImpute}. To call these methods, please follow these steps:
1) install scImpute and/or SCRABBLE from their github repositories
2) clone the ADImpute repository
3) copy the lines below to the file Wrap.R in the source R/ folder of ADImpute,
line #309.
4) re-load ADImpute using devtools::load_all() on ADImpute's folder
```{r, warning=FALSE, eval=FALSE}
# # call to scImpute
if('scimpute' %in% tolower(do)){
    message('Make sure you have previously installed scImpute via GitHub.\n')
    res <- tryCatch(ImputeScImpute(count_path, labeled = is.null(labels),
            Kcluster = cell.clusters, labels = labels, drop_thre = drop_thre,
            cores = cores, type = type, tr.length = tr.length),
        error = function(e){ stop(paste('Error:', e$message,
            '\nTry sourcing the Impute_extra.R file.'))})
    imputed$scImpute <- log2( (res / scale) + pseudo.count)
}

# call to SCRABBLE
if('scrabble' %in% tolower(do)){
    message('Make sure you have previously installed SCRABBLE via GitHub.\n')
    res <- tryCatch(ImputeSCRABBLE(data, bulk),
                    error = function(e) { stop(paste('Error:', e$message,
                        '\nTry sourcing the Impute_extra.R file.'))})
    imputed$SCRABBLE <- log2( (res / scale) + pseudo.count)
    rm(res);gc()
}
```
After these steps, \code{scImpute} and \code{SCRABBLE} can be run with
\code{EvaluateMethods} or \code{Impute()} with
\code{do = c("scImpute","SCRABBLE")}.

# Session Info
```{r}
sessionInfo()
```

ADImpute was developed in R 4.0.2, under Linux Mint 20, and tested in Linux,
OS X and Windows. For further questions, please contact:
ana.carolina.leote@uni-koeln.de

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{DataCheck_TrLength}
\alias{DataCheck_TrLength}
\title{Data check (transcript length)}
\usage{
DataCheck_TrLength(trlength)
}
\arguments{
\item{trlength}{data object containing transcript length information}
}
\value{
transcript length object with needed adjustments
}
\description{
\code{DataCheck_TrLength} tests for potential format and
storage issues with the object encoding transcript length, for e.g. TPM
normalization. Helper function to ADImpute.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{CheckArguments_Impute}
\alias{CheckArguments_Impute}
\title{Argument check to Impute()}
\usage{
CheckArguments_Impute(data, method.choice, do, tr.length, labels,
cell.clusters, true.zero.thr, drop_thre)
}
\arguments{
\item{data}{matrix; raw counts (genes as rows and samples as columns)}

\item{method.choice}{character; best performing method in training data for
each gene}

\item{do}{character; choice of methods to be used for imputation. Currently
supported methods are \code{'Baseline'}, \code{'DrImpute'},
\code{'Network'}, and \code{'Ensemble'}. Defaults to \code{'Ensemble'}.
Not case-sensitive. Can include one or more methods. Non-supported methods
will be ignored.}

\item{tr.length}{matrix with at least 2 columns: 'hgnc_symbol' and
'transcript_length'}

\item{labels}{character; vector specifying the cell type of each column of
\code{data}}

\item{cell.clusters}{integer; number of cell subpopulations}

\item{true.zero.thr}{if set to NULL (default), no true zero estimation is
performed. Set to numeric value between 0 and 1 for estimation. Value
corresponds to the threshold used to determine true zeros: if the probability
of dropout is lower than \code{true.zero.thr}, the imputed entries are set
to zero.}

\item{drop_thre}{numeric; between 0 and 1 specifying the threshold to
determine dropout values}
}
\value{
NULL object
}
\description{
\code{CheckArguments_Impute} checks whether the arguments passed
to \code{Impute} are correct.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NetworkFunctions.R
\name{ImputeNPDropouts}
\alias{ImputeNPDropouts}
\title{Helper function to PseudoInverseSolution_percell}
\usage{
ImputeNPDropouts(net, expr)
}
\arguments{
\item{net}{matrix, logical; network coefficients for all dropout (to be
imputed) genes that are predictive of the expression of other dropout genes}

\item{expr}{numeric; vector of gene expression for all genes in the cell at
hand}
}
\value{
vector; imputation results for the non-dropout-dependent genes
}
\description{
\code{ImputeNPDropouts} computes the non-dropout-
dependent solution of network imputation for each cell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NetworkFunctions.R
\name{ImputeNetParallel}
\alias{ImputeNetParallel}
\title{Network-based parallel imputation}
\usage{
ImputeNetParallel(drop.mat, arranged, cores =
BiocParallel::bpworkers(BPPARAM), type = 'iteration', max.iter = 50,
BPPARAM = BiocParallel::SnowParam(type = "SOCK"))
#'
}
\arguments{
\item{drop.mat}{matrix, logical; dropout entries in the data matrix
(genes as rows and samples as columns)}

\item{arranged}{list; output of \code{\link{ArrangeData}}}

\item{cores}{integer; number of cores used for paralell computation}

\item{type}{character; either 'iteration', for an iterative solution, or
'pseudoinv', to use Moore-Penrose pseudo-inversion as a solution.}

\item{max.iter}{numeric; maximum number of iterations for network
imputation. Set to -1 to remove limit (not recommended)}

\item{BPPARAM}{parallel back-end to be used during parallel computation.
See \code{\link[BiocParallel]{BiocParallelParam-class}}.}
}
\value{
matrix; imputation results incorporating network information
}
\description{
\code{ImputeNetParallel} implements network-based imputation
in parallel
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NetworkFunctions.R
\name{CenterData}
\alias{CenterData}
\title{Data centering}
\usage{
CenterData(data)
}
\arguments{
\item{data}{matrix of gene expression to be centered row-wise (genes as rows
and samples as columns)}
}
\value{
list; row-wise centers and centered data
}
\description{
\code{CenterData} centers expression of each gene at 0
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NetworkFunctions.R
\name{ArrangeData}
\alias{ArrangeData}
\title{Data trimming}
\usage{
ArrangeData(data, net.coef = NULL)
}
\arguments{
\item{data}{matrix with entries equal to zero to be imputed (genes as rows
and samples as columns)}

\item{net.coef}{matrix; object containing network coefficients}
}
\value{
list; data matrix, network coefficients matrix and intercept for
genes common between the data matrix and the network
}
\description{
\code{ArrangeData} finds common genes to the network and
provided data and limits both datasets to these
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_documentation.R
\docType{data}
\name{demo_data}
\alias{demo_data}
\title{Small dataset for example purposes}
\format{
matrix; a subset of the Grun pancreas dataset, obtained with the
\code{scRNAseq} R package, to use in the vignette and examples.
}
\usage{
demo_data
}
\description{
A small dataset to use on vignettes and examples (50 cells).
}
\references{
Grun D et al. (2016). De novo prediction of stem cell identity
using single-cell transcriptome data. Cell Stem Cell 19(2), 266-277.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Read_Write.R
\name{WriteCSV}
\alias{WriteCSV}
\title{Write csv file}
\usage{
WriteCSV(object, file)
}
\arguments{
\item{object}{R object to write}

\item{file}{character; path to output file}
}
\value{
Returns NULL
}
\description{
\code{WriteCSV} writes data to a comma-delimited output file
}
\examples{
file <- tempfile()
WriteCSV(iris, file = file)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GenewiseMethod.R
\name{ChooseMethod}
\alias{ChooseMethod}
\title{Method choice per gene}
\usage{
ChooseMethod(real, masked, imputed, write.to.file = TRUE)
}
\arguments{
\item{real}{matrix; original gene expression data, i.e. before masking
(genes as rows and samples as columns)}

\item{masked}{matrix, logical indicating which entries were masked
(genes as rows and samples as columns)}

\item{imputed}{list; list of matrices with imputation results for all
considered methods}

\item{write.to.file}{logical; should the output be written to a file?}
}
\value{
character; best performing method in the training set for each gene
}
\description{
\code{ChooseMethod} determines the method for dropout
imputation based on performance on each gene in training data
}
\details{
The imputed values are compared to the real ones for every masked
entry in \code{real}. The Mean Squared Error
is computed for all masked entries per gene and the method with the best
performance is chosen for each gene.
}
\seealso{
\code{\link{ComputeMSEGenewise}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GenewiseMethod.R
\name{CreateTrainData}
\alias{CreateTrainData}
\title{Preparation of training data for method evaluation}
\usage{
CreateTrainData(data, train.ratio = .7, train.only = TRUE, mask = .1,
write = FALSE)
}
\arguments{
\item{data}{matrix; raw counts (genes as rows and samples as columns)}

\item{train.ratio}{numeric; ratio of the samples to be used for training}

\item{train.only}{logical; if TRUE define only a training dataset, if
FALSE writes both training and validation sets (defaults to TRUE)}

\item{mask}{numeric; ratio of total non-zero samples to be masked per gene
(defaults to .1)}

\item{write}{logical; should the output be written to a file?}
}
\value{
list with resulting matrix after subsetting and after masking
}
\description{
\code{CreateTrainingData} selects a subset of cells to use as
training set and sets a portion (\code{mask}) of the non-zero entries in each
row of the subset to zero
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GenewiseMethod.R
\name{MaskData}
\alias{MaskData}
\title{Masking of entries for performance evaluation}
\usage{
MaskData(data, write.to.file = FALSE, mask = .1)
}
\arguments{
\item{data}{matrix; raw counts (genes as rows and samples as columns)}

\item{write.to.file}{logical; should the output be written to a file?}

\item{mask}{numeric; ratio of total non-zero samples to be masked per gene
(defaults to .1)}
}
\value{
matrix containing masked raw counts (genes as rows and samples as
columns)
}
\description{
\code{MaskData} sets a portion (\code{mask}) of the non-zero
entries of each row of \code{data} to zero
}
\details{
Sets a portion (\code{mask}) of the non-zero entries of each row of
\code{data} to zero. Result is written to \code{filename}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Impute.R
\name{ImputeDrImpute}
\alias{ImputeDrImpute}
\title{Use DrImpute}
\usage{
ImputeDrImpute(data, write = FALSE)
}
\arguments{
\item{data}{matrix with entries equal to zero to be imputed, normalized
and log2-transformed (genes as rows and samples as columns)}

\item{write}{logical; should a file with the imputation results be written?}
}
\value{
matrix; imputation results from DrImpute
}
\description{
\code{ImputeDrImpute} uses the DrImpute package for dropout
imputation
}
\seealso{
\code{\link[DrImpute]{DrImpute}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Impute.R
\name{Combine}
\alias{Combine}
\title{Combine imputation methods}
\usage{
Combine(data, imputed, method.choice, write = FALSE)
}
\arguments{
\item{data}{matrix with entries equal to zero to be imputed, already
normalized (genes as rows and samples as columns)}

\item{imputed}{list; list of matrices with imputation results for all
considered methods}

\item{method.choice}{named character; vector with the best performing method
per gene}

\item{write}{logical; should a file with the imputation results be written?}
}
\value{
matrix; imputation results combining the best performing method
per gene
}
\description{
Combine imputation methods
}
\details{
Combines imputation results from all methods according to training
results provided in \code{method.choice}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{ReturnChoice}
\alias{ReturnChoice}
\title{Wrapper for return of EvaluateMethods()}
\usage{
ReturnChoice(sce, choice)
}
\arguments{
\item{sce}{SingleCellExperiment; a SingleCellExperiment object if available;
NULL otherwise}

\item{choice}{character; best performing method in the training set for each
gene}
}
\value{
\itemize{
    \item if \code{sce} is provided: returns a SingleCellExperiment with the
    best performing method per gene stored as row-features. Access via
    \code{SingleCellExperiment::int_elementMetadata(sce)$ADImpute$methods}.
    \item if \code{sce} is not provided: returns a character with the best
    performing method in the training set for each gene
}
}
\description{
\code{ReturnChoice} Adjusts the output of \code{EvaluateMethods}
to a character vector or a SingleCellExperiment object. Helper function to
ADImpute.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{CreateArgCheck}
\alias{CreateArgCheck}
\title{Argument check}
\usage{
CreateArgCheck(missing = NULL, match = NULL, acceptable = NULL,
null = NULL)
}
\arguments{
\item{missing}{named list; logical. Name corresponds to variable name, and
corresponding entry to whether it was missing from the function call.}

\item{match}{named list. Name corresponds to variable name, and corresponding
entry to its value.}

\item{acceptable}{named list. Name corresponds to variable name, and
corresponding entry to its acceptable values.}

\item{null}{named list; logical. Name corresponds to variable name, and
corresponding entry to whether it was NULL in the function call.}
}
\value{
argument check object.
}
\description{
\code{CreateArgCheck} creates tests for argument correctness.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{ReturnOut}
\alias{ReturnOut}
\title{Wrapper for return of Impute()}
\usage{
ReturnOut(result, sce)
}
\arguments{
\item{result}{list; imputation result}

\item{sce}{SingleCellExperiment; a SingleCellExperiment object if available;
NULL otherwise}
}
\value{
imputation results. A SingleCellExperiment if \code{!is.null(sce)},
or a list with imputed results in matrix format otherwise.
}
\description{
\code{ReturnOut} Adjusts the output of \code{Impute} to a list
of matrices or a SingleCellExperiment object. Helper function to ADImpute.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Normalize.R
\name{NormalizeTPM}
\alias{NormalizeTPM}
\title{TPM normalization}
\usage{
NormalizeTPM(data, sce = NULL, tr_length = NULL, log = FALSE,
scale = 1, pseudo.count = 1)
}
\arguments{
\item{data}{matrix; raw data (genes as rows and samples as columns)}

\item{sce}{SingleCellExperiment; raw data}

\item{tr_length}{data.frame with at least 2 columns: 'hgnc_symbol'
and 'transcript_length'}

\item{log}{logical; log TPMs?}

\item{scale}{integer; scale factor to divide TPMs by}

\item{pseudo.count}{numeric; if \code{log = T}, value to add to TPMs in order
to avoid taking \code{log(0)}}
}
\value{
matrix; normalized data (for transcript length and library size)
}
\description{
\code{NormalizeTPM} performs TPM normalization, with possibility
to log the result
}
\details{
Gene length is estimated as the median of the lengths of all
transcripts for each gene, as obtained from biomaRt.
Genes for which length information cannot be found in biomaRt are dropped.
}
\examples{
demo <- NormalizeTPM(ADImpute::demo_data)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BiologicalZeros.R
\name{SetBiologicalZeros}
\alias{SetBiologicalZeros}
\title{Set biological zeros}
\usage{
SetBiologicalZeros(imputation, drop_probs, thre = .2, was_zero)
}
\arguments{
\item{imputation}{matrix; imputed values}

\item{drop_probs}{matrix; dropout probabilities for each entry in
\code{imputation}. 0 means certain biological zero, while 1 means certain
dropout to be imputed}

\item{thre}{numeric; probability threshold to classify entries as biological
zeros}

\item{was_zero}{matrix; logical matrix: was the corresponding entry of
\code{imputation} originally a zero?}
}
\value{
matrix containing likely biological zeros set back to 0.
}
\description{
\code{SetBiologicalZeros} sets some of the entries back to zero
after dropout imputation, as they likely correspond to true biological zeros
(genes not expressed in given cell)
}
\details{
Entries which were originally zero and have dropout probability
below \code{thre} are considered biological zeros and, if they were imputed,
are set back to 0.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_documentation.R
\docType{data}
\name{network.coefficients}
\alias{network.coefficients}
\title{Transcriptome wide gene regulatory network}
\format{
dgCMatrix
}
\usage{
network.coefficients
}
\description{
Gene Regulatory Network used by ADImpute's Network imputation
method. First column, \code{O}, corresponds to the intercept of a gene-
-specific predicion model. The remaining rows and columns correspond to the
adjacency matrix of the inferred network, where rows are target genes and
columns are predictors. Genes are identified by their hgnc_symbol.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Impute.R
\name{ImputeNetwork}
\alias{ImputeNetwork}
\title{Network-based imputation}
\usage{
ImputeNetwork(data, net.coef = NULL,
cores = BiocParallel::bpworkers(BPPARAM),
BPPARAM = BiocParallel::SnowParam(type = "SOCK"),
type = 'iteration', write = FALSE, ...)
}
\arguments{
\item{data}{matrix with entries equal to zero to be imputed, normalized
and log2-transformed (genes as rows and samples as columns)}

\item{net.coef}{matrix; network coefficients.}

\item{cores}{integer; number of cores to use}

\item{BPPARAM}{parallel back-end to be used during parallel computation.
See \code{\link[BiocParallel]{BiocParallelParam-class}}.}

\item{type}{character; either 'iteration', for an iterative solution, or
'pseudoinv', to use Moore-Penrose pseudo-inversion as a solution.}

\item{write}{logical; should a file with the imputation results be written?}

\item{...}{additional arguments to \code{ImputeNetParallel}}
}
\value{
matrix; imputation results incorporating network information
}
\description{
Network-based imputation
}
\details{
Imputes dropouts using a gene regulatory network trained on external
data, as provided in \code{net.coef}. Dropout expression values are
estimated from the expression of their predictor genes and the network
coefficients.
}
\seealso{
\code{\link{ImputeNetParallel}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GenewiseMethod.R
\name{ComputeMSEGenewise}
\alias{ComputeMSEGenewise}
\title{Computation of MSE per gene}
\usage{
ComputeMSEGenewise(real, masked, imputed, baseline)
}
\arguments{
\item{real}{numeric; vector of original expression of a given gene (before
masking)}

\item{masked}{logical; vector indicating which entries were masked for a
given gene}

\item{imputed}{matrix; imputation results for a given imputation method}

\item{baseline}{logical; is this baseline imputation?}
}
\value{
MSE of all imputations indicated by \code{masked}
}
\description{
\code{ComputeMSEGenewise} computes the MSE of dropout
imputation for a given gene.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Normalize.R
\name{NormalizeRPM}
\alias{NormalizeRPM}
\title{RPM normalization}
\usage{
NormalizeRPM(data, sce = NULL, log = FALSE, scale = 1,
pseudo.count = 1)
}
\arguments{
\item{data}{matrix; raw data (genes as rows and samples as columns)}

\item{sce}{SingleCellExperiment; raw data}

\item{log}{logical; log RPMs?}

\item{scale}{integer; scale factor to divide RPMs by}

\item{pseudo.count}{numeric; if \code{log = TRUE}, value to add to RPMs in
order to avoid taking \code{log(0)}}
}
\value{
matrix; library size normalized data
}
\description{
\code{NormalizeRPM} performs RPM normalization, with possibility
to log the result
}
\examples{
demo <- NormalizeRPM(ADImpute::demo_data)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Impute.R
\name{ImputeBaseline}
\alias{ImputeBaseline}
\title{Impute using average expression across all cells}
\usage{
ImputeBaseline(data, write = FALSE, ...)
}
\arguments{
\item{data}{matrix with entries equal to zero to be imputed, normalized
and log2-transformed (genes as rows and samples as columns)}

\item{write}{logical; should a file with the imputation results be written?}

\item{...}{additional arguments to \code{saveRDS}}
}
\value{
matrix; imputation results considering the average expression
values of genes
}
\description{
\code{ImputeBaseline} imputes dropouts using gene averages
across cells. Zero values are excluded from the mean computation.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BiologicalZeros.R
\name{GetDropoutProbabilities}
\alias{GetDropoutProbabilities}
\title{Get dropout probabilities}
\usage{
GetDropoutProbabilities(data, thre, cell.clusters, labels = NULL,
type = 'count', cores, BPPARAM, genelen = ADImpute::transcript_length)
}
\arguments{
\item{data}{matrix; original data before imputation}

\item{thre}{numeric; probability threshold to classify entries as biological
zeros}

\item{cell.clusters}{integer; number of cell subpopulations}

\item{labels}{character; vector specifying the cell type of each column of
\code{data}}

\item{type}{A character specifying the type of values in the expression
matrix. Can be 'count' or 'TPM'}

\item{cores}{integer; number of cores used for paralell computation}

\item{BPPARAM}{parallel back-end to be used during parallel computation.
See \code{\link[BiocParallel]{BiocParallelParam-class}}.}

\item{genelen}{matrix with at least 2 columns: 'hgnc_symbol' and
'transcript_length'}
}
\value{
matrix with same dimensions as \code{data} containing the dropout
probabilities for the corresponding entries
}
\description{
\code{GetDropoutProbabilities} computes dropout probabilities
(probability of being a dropout that should be imputed rather than a true
biological zero) using an adaptation of scImpute's approach
}
\details{
This function follows scImpute's model to distinguish between
true biological zeros and dropouts, and is based on adapted code from the
scImpute R package.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{DataCheck_Matrix}
\alias{DataCheck_Matrix}
\title{Data check (matrix)}
\usage{
DataCheck_Matrix(data)
}
\arguments{
\item{data}{data object to check}
}
\value{
data object with needed adjustments
}
\description{
\code{DataCheck_Matrix} tests for potential format and storage
issues with matrices. Helper function to ADImpute.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GenewiseMethod.R
\name{MaskerPerGene}
\alias{MaskerPerGene}
\title{Helper mask function}
\usage{
MaskerPerGene(x, rowmask)
}
\arguments{
\item{x}{logical; data to mask}

\item{rowmask}{numeric; number of samples to be masked per gene}
}
\value{
logical containing positions to mask
}
\description{
Helper mask function, per feature.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NetworkFunctions.R
\name{PseudoInverseSolution_percell}
\alias{PseudoInverseSolution_percell}
\title{Network-based parallel imputation - Moore-Penrose pseudoinversion}
\usage{
PseudoInverseSolution_percell(expr, net, drop_ind, thr = 0.01)
}
\arguments{
\item{expr}{numeric; expression vector for cell at hand}

\item{net}{matrix; network coefficients}

\item{drop_ind}{logical; dropout entries in the cell at hand}

\item{thr}{numeric; tolerance threshold to detect zero singular values}
}
\value{
matrix; imputation results incorporating network information
}
\description{
\code{PseudoInverseSolution_percell} applies Moore-Penrose
pseudo-inversion to compute the solution of network imputation for each
cell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Wrap.R
\name{EvaluateMethods}
\alias{EvaluateMethods}
\title{Imputation method evaluation on training set}
\usage{
EvaluateMethods(data, sce = NULL, do = c('Baseline', 'DrImpute',
'Network'), write = FALSE, train.ratio = .7, train.only = TRUE,
mask.ratio = .1, outdir = getwd(), scale = 1, pseudo.count = 1,
labels = NULL, cell.clusters = 2, drop_thre = NULL, type = 'count',
cores = BiocParallel::bpworkers(BPPARAM),
BPPARAM = BiocParallel::SnowParam(type = "SOCK"),
net.coef = ADImpute::network.coefficients, net.implementation = 'iteration',
tr.length = ADImpute::transcript_length, bulk = NULL, ...)
}
\arguments{
\item{data}{matrix; normalized counts, not logged (genes as rows and samples
as columns)}

\item{sce}{SingleCellExperiment; normalized counts and associated metadata.}

\item{do}{character; choice of methods to be used for imputation. Currently
supported methods are \code{'Baseline'}, \code{'DrImpute'} and
\code{'Network'}. Not case-sensitive. Can include one or more methods. Non-
supported methods will be ignored.}

\item{write}{logical; write intermediary and imputed objects to files?}

\item{train.ratio}{numeric; ratio of samples to be used for training}

\item{train.only}{logical; if TRUE define only a training dataset, if
FALSE writes and returns both training and validation sets (defaults to TRUE)}

\item{mask.ratio}{numeric; ratio of samples to be masked per gene}

\item{outdir}{character; path to directory where output files are written.
Defaults to working directory}

\item{scale}{integer; scaling factor to divide all expression levels by
(defaults to 1)}

\item{pseudo.count}{integer; pseudo-count to be added to expression levels
to avoid log(0) (defaults to 1)}

\item{labels}{character; vector specifying the cell type of each column of
\code{data}}

\item{cell.clusters}{integer; number of cell subpopulations}

\item{drop_thre}{numeric; between 0 and 1 specifying the threshold to
determine dropout values}

\item{type}{A character specifying the type of values in the expression
matrix. Can be 'count' or 'TPM'}

\item{cores}{integer; number of cores used for paralell computation}

\item{BPPARAM}{parallel back-end to be used during parallel computation.
See \code{\link[BiocParallel]{BiocParallelParam-class}}.}

\item{net.coef}{matrix; network coefficients. Please provide if you don't
want to use ADImpute's network model. Must contain one first column 'O'
acconting for the intercept of the model and otherwise be an adjacency matrix
with hgnc_symbols in rows and columns. Doesn't have to be squared. See
\code{ADImpute::demo_net} for a small example.}

\item{net.implementation}{character; either 'iteration', for an iterative
solution, or 'pseudoinv', to use Moore-Penrose pseudo-inversion as a
solution. 'pseudoinv' is not advised for big data.}

\item{tr.length}{matrix with at least 2 columns: 'hgnc_symbol' and
'transcript_length'}

\item{bulk}{vector of reference bulk RNA-seq, if available (average across
samples)}

\item{...}{additional parameters to pass to network-based imputation}
}
\value{
\itemize{
    \item if \code{sce} is provided: returns a SingleCellExperiment with the
    best performing method per gene stored as row-features. Access via
    \code{SingleCellExperiment::int_elementMetadata(sce)$ADImpute$methods}.
    \item if \code{sce} is not provided: returns a character with the best
    performing method in the training set for each gene
}
}
\description{
\code{EvaluateMethods} returns the best-performing imputation
method for each gene in the dataset
}
\details{
For each gene, a fraction (\code{mask.ratio}) of the quantified
expression values are set to zero and imputed according to 3 different
methods: scImpute, baseline (average gene expression across all cells) or a
network-based method. The imputation error is computed for each of the
values in the original dataset that was set to 0, for each method. The
method resulting in a lowest imputation error for each gene is chosen.
}
\examples{
# Normalize demo data
norm_data <- NormalizeRPM(ADImpute::demo_data)
method_choice <- EvaluateMethods(norm_data, do = c('Baseline','DrImpute'),
cores = 2)

}
\seealso{
\code{\link{ImputeBaseline}},
\code{\link{ImputeDrImpute}},
\code{\link{ImputeNetwork}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Impute.R
\name{ImputeSAVER}
\alias{ImputeSAVER}
\title{Use SAVER}
\usage{
ImputeSAVER(data, cores, try.mean = FALSE, write = FALSE)
}
\arguments{
\item{data}{matrix with entries equal to zero to be imputed, normalized
(genes as rows and samples as columns)}

\item{cores}{integer; number of cores to use}

\item{try.mean}{logical; whether to additionally use mean gene expression
as prediction}

\item{write}{logical; should a file with the imputation results be written?}
}
\value{
matrix; imputation results from SAVER
}
\description{
\code{ImputeSAVER} uses the SAVER package for dropout
imputation
}
\seealso{
\code{\link[SAVER]{saver}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GenewiseMethod.R
\name{SplitData}
\alias{SplitData}
\title{Selection of samples for training}
\usage{
SplitData(data, ratio = .7, write.to.file = FALSE, train.only = TRUE)
}
\arguments{
\item{data}{matrix; raw counts (genes as rows and samples as columns)}

\item{ratio}{numeric; ratio of the samples to be used for training}

\item{write.to.file}{logical; should the output be written to a file?}

\item{train.only}{logical; if TRUE define only a training dataset, if
FALSE writes both training and validation sets (defaults to TRUE)}
}
\value{
matrix containing raw counts (genes as rows and samples as columns)
}
\description{
\code{SplitData} selects a portion (\code{ratio}) of samples
(columns in \code{data}) to be used as training set
}
\details{
Selects a portion (\code{ratio}) of samples (columns in \code{data})
to be used as training set and writes to file 'training_raw.txt'.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_documentation.R
\docType{data}
\name{transcript_length}
\alias{transcript_length}
\title{Table for transcript length calculations}
\format{
A data.frame with 2 columns:
\describe{
\item{hgnc_symbol}{Gene symbol identifier}
\item{transcript length}{Length of transcript}
}
}
\usage{
transcript_length
}
\description{
A data.frame to be used for transcript length computations.
May be necessary upon TPM normalization, or as input to \code{scImpute}.
All data was retrieved from \code{biomaRt}.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data_documentation.R
\docType{data}
\name{demo_net}
\alias{demo_net}
\title{Small regulatory network for example purposes}
\format{
matrix; subset of the Gene Regulatory Network installed along with
ADImpute.
}
\usage{
demo_net
}
\description{
Subset of the Gene Regulatory Network used by ADImpute's Network
imputation method.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{DataCheck_SingleCellExperiment}
\alias{DataCheck_SingleCellExperiment}
\title{Data check (SingleCellExperiment)}
\usage{
DataCheck_SingleCellExperiment(sce, normalized = TRUE)
}
\arguments{
\item{sce}{SingleCellExperiment; data for normalization or imputation}

\item{normalized}{logical; is the data expected to be normalized?}
}
\value{
NULL object.
}
\description{
\code{DataCheck_SingleCellExperiment} tests for existence of the
appropriate assays in \code{sce}. Helper function to ADImpute.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Helper.R
\name{DataCheck_Network}
\alias{DataCheck_Network}
\title{Data check (network)}
\usage{
DataCheck_Network(network)
}
\arguments{
\item{network}{data object containing matrix coefficients}
}
\value{
network data object with needed adjustments
}
\description{
\code{DataCheck_Network} tests for potential format and storage
issues with the network coefficient matrix. Helper function to ADImpute.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Read_Write.R
\name{ReadData}
\alias{ReadData}
\title{Data read}
\usage{
ReadData(path, ...)
}
\arguments{
\item{path}{character; path to input file}

\item{...}{additional arguments to \code{data.table::fread()}}
}
\value{
matrix; raw counts (genes as rows and samples as columns)
}
\description{
\code{ReadData} reads data from raw input file (.txt or .csv)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NetworkFunctions.R
\name{ImputePredictiveDropouts}
\alias{ImputePredictiveDropouts}
\title{Helper function to PseudoInverseSolution_percell}
\usage{
ImputePredictiveDropouts(net, thr = 0.01, expr)
}
\arguments{
\item{net}{matrix, logical; network coefficients for all dropout (to be
imputed) genes that are predictive of the expression of other dropout genes}

\item{thr}{numeric; tolerance threshold to detect zero singular values}

\item{expr}{numeric; vector of gene expression for all genes in the cell at
hand}
}
\value{
vector; imputation results for the dropout-dependent genes
}
\description{
\code{ImputePredictiveDropouts} applies Moore-Penrose
pseudo-inversion to compute the dropout-dependent solution of network
imputation for each cell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Wrap.R
\name{Impute}
\alias{Impute}
\title{Dropout imputation using different methods}
\usage{
Impute(data, sce = NULL, do = 'Ensemble', write = FALSE,
outdir = getwd(), method.choice = NULL, scale = 1, pseudo.count = 1,
labels = NULL, cell.clusters = 2, drop_thre = NULL, type = 'count',
tr.length = ADImpute::transcript_length,
cores = BiocParallel::bpworkers(BPPARAM),
BPPARAM = BiocParallel::SnowParam(type = "SOCK"),
net.coef = ADImpute::network.coefficients, net.implementation = 'iteration',
bulk = NULL, true.zero.thr = NULL, prob.mat = NULL, ...)
}
\arguments{
\item{data}{matrix; raw counts (genes as rows and samples as columns)}

\item{sce}{SingleCellExperiment; normalized counts and associated metadata.}

\item{do}{character; choice of methods to be used for imputation. Currently
supported methods are \code{'Baseline'}, \code{'DrImpute'},
\code{'Network'}, and \code{'Ensemble'}. Defaults to \code{'Ensemble'}.
Not case-sensitive. Can include one or more methods. Non-supported methods
will be ignored.}

\item{write}{logical; write intermediary and imputed objects to files?}

\item{outdir}{character; path to directory where output files are written.
Defaults to working directory}

\item{method.choice}{character; best performing method in training data for
each gene}

\item{scale}{integer; scaling factor to divide all expression levels by
(defaults to 1)}

\item{pseudo.count}{integer; pseudo-count to be added to expression levels
to avoid log(0) (defaults to 1)}

\item{labels}{character; vector specifying the cell type of each column of
\code{data}}

\item{cell.clusters}{integer; number of cell subpopulations}

\item{drop_thre}{numeric; between 0 and 1 specifying the threshold to
determine dropout values}

\item{type}{A character specifying the type of values in the expression
matrix. Can be 'count' or 'TPM'}

\item{tr.length}{matrix with at least 2 columns: 'hgnc_symbol' and
'transcript_length'}

\item{cores}{integer; number of cores used for paralell computation}

\item{BPPARAM}{parallel back-end to be used during parallel computation.
See \code{\link[BiocParallel]{BiocParallelParam-class}}.}

\item{net.coef}{matrix; network coefficients. Please provide if you don't
want to use ADImpute's network model. Must contain one first column 'O'
acconting for the intercept of the model and otherwise be an adjacency matrix
with hgnc_symbols in rows and columns. Doesn't have to be squared. See
\code{ADImpute::demo_net} for a small example.}

\item{net.implementation}{character; either 'iteration', for an iterative
solution, or 'pseudoinv', to use Moore-Penrose pseudo-inversion as a
solution. 'pseudoinv' is not advised for big data.}

\item{bulk}{vector of reference bulk RNA-seq, if available (average across
samples)}

\item{true.zero.thr}{if set to NULL (default), no true zero estimation is
performed. Set to numeric value between 0 and 1 for estimation. Value
corresponds to the threshold used to determine true zeros: if the probability
of dropout is lower than \code{true.zero.thr}, the imputed entries are set
to zero.}

\item{prob.mat}{matrix of the same size as data, filled with the dropout
probabilities for each gene in each cell}

\item{...}{additional parameters to pass to network-based imputation}
}
\value{
\itemize{
    \item if \code{sce} is not set: returns a list of imputation results
    (normalized, log-transformed) for all selected methods in \code{do}. If
    \code{true.zero.thr} is defined, returns a list of 3 elements: 1) a list,
    \code{imputations}, containing the direct imputation results from each
    method; 2) a list, \code{zerofiltered}, containing the results of
    imputation in \code{imputations} after setting biological zeros back to
    zero; 3) a matrix, \code{dropoutprobabilities}, containing the dropout
    probability matrix used to set biological zeros.
    \item if \code{sce} is set: returns a SingleCellExperiment with new
    assays, each corresponding to one of the imputation methods applied. If
    \code{true.zero.thr} is defined, the assays will contain the results
    after imputation and setting biological zeros back to zero.
}
}
\description{
\code{Impute} performs dropout imputation on normalized data,
based on the choice of imputation methods.
}
\details{
Values that are 0 in \code{data} are imputed according to the
best-performing methods indicated in \code{method.choice}. Currently
supported methods are:
\itemize{
    \item \code{Baseline}: imputation with average expression across all
cells in the dataset. See \code{\link{ImputeBaseline}}.
    \item Previously published approaches: \code{DrImpute} and \code{SAVER}.
    \item \code{Network}: leverages information from a gene regulatory
network to predicted expression of genes that are not quantified based on
quantified interacting genes, in the same cell. See
\code{\link{ImputeNetwork}}.
    \item \code{Ensemble}: is based on results on a training subset of the
data at hand, indicating which method best predicts the expression of
each gene. These results are supplied via \code{method.choice}. Applies
the imputation results of the best performing method to the zero entries
of each gene.
}
If \code{'Ensemble'} is included in \code{do}, \code{method.choice} has to
be provided (use output from \code{EvaluateMethods()}).
\code{Impute} can create a directory \code{imputation} containing the
imputation results of all methods in \code{do}.
If \code{true.zero.thr} is set, dropout probabilities are computed using
scImpute's framework. Expression values with dropout probabilities below
\code{true.zero.thr} will be set back to 0 if imputed, as they likely
correspond to true biological zeros (genes not expressed in cell) rather than
technical dropouts (genes expressed but not captured).
If \code{sce} is set, imputed values by the different methods are added as
new assays to \code{sce}. Each assay corresponds to one imputation method. If
\code{true.zero.thr} is set, only the values after filtering for biological
zeros will be added. This is different from the output if \code{sce} is not
set, where the original values before filtering and the dropout probability
matrix are returned.
}
\examples{
# Normalize demo data
norm_data <- NormalizeRPM(demo_data)
# Impute with particular method(s)
imputed_data <- Impute(do = 'Network', data = norm_data[,1:10],
net.coef = ADImpute::demo_net)
imputed_data <- Impute(do = 'Network', data = norm_data[,1:10],
net.implementation = 'pseudoinv', net.coef = ADImpute::demo_net)

}
\seealso{
\code{\link{EvaluateMethods}},
\code{\link{ImputeBaseline}},
\code{\link{ImputeDrImpute}},
\code{\link{ImputeNetwork}},
\code{\link{ImputeSAVER}}
}
